#ifndef __vpu_LabelStack_h
#define __vpu_LabelStack_h


#include "List.h"


class LocalLabel;


class LabelStack : public List<LocalLabel>
{
public:

  LabelStack *push(Heap *heap, LocalLabel *i)
  {
    addFirst(heap, i);
    return this;
  }

  LabelStack *pop(int n= 1)
  {
    while (n--) removeFirst();
    return this;
  }
};


#endif // __vpu_LabelStack_h
