#ifndef __vpu_LocalLabel_h
#define __vpu_LocalLabel_h


#include "Heap.h"
 

class Ldef;


class LocalLabel : public Bulk
{
  static int nextSeq;
  int   seq;

public:
  void *value;
  Ldef *definition;

  LocalLabel(void) { seq= nextSeq++; value= 0; definition= 0; }

  inline void define(void *a) { value= a; }

  inline operator void *(void) { return value; }

  int  print(void);
  void println(void);
};


#include "List.h"


class LabelList : public List<LocalLabel>
{
public:
};


#endif // __vpu_LocalLabel_h
