#ifndef __vpu_debug_h
#define __vpu_debug_h

#define debug(LEVEL, ACTION)	\
  if (VPU::debug & (1 << VPU::Debug##LEVEL)) { ACTION; }

#define vebug(LEVEL, ACTION)	\
  if (VPU::debug & (1 << VPU::Debug##LEVEL) && VPU::debug & (1 << VPU::DebugVerbose)) { ACTION; }

#define ifDump(aVPU,LEVEL, ACTION) \
  if (aVPU->flags & (1 << VPU::Dump##LEVEL)) { ACTION; }

#define ifVump(aVPU,LEVEL, ACTION) \
  if (aVPU->flags & (1 << VPU::Dump##LEVEL) && VPU::debug & (1 << VPU::DebugVerbose)) { ACTION; }

#endif // __vpu_debug_h
