{ import: Object-imp }
{ import: Object-lib }
{ import: CokeScanner }
{ import: compile }

Options : Object ( verbose )

Options verbose	[ ^verbose ]

Options new
[
    self := super new.
    verbose := false.
]

[ Options := Options new ]
    
Options parseOption: aString
[
    aString = '-ve' ifTrue: [^verbose := true].
    ^false
]

[
    | echo args file scanner expr |
    (args := OS arguments) isEmpty ifTrue: [args := Array with: '-'].
    args do: [:path |
	((Options parseOption: path) or: [Compiler parseOption: path])
	    ifFalse:
	       [file := (path = '-') ifTrue: [StdIn] ifFalse: [File open: path].
		file isNil ifTrue: [path error: path, ': No such file or directory'].
		file isInteractive
		    ifTrue: [StdOut
				 nextPutAll: 'Welcome to Jolt 0.1 [';
				 nextPutAll: VPU versionString;
				 nextPutAll: ']\n'].
		scanner := CokeScanner on: file readStream.
		echo := Options verbose or: [file isInteractive].
		" read - eval - print "
		[(expr := scanner next) isNil]
		    whileFalse:
			[Options verbose ifTrue: [StdErr print: expr; cr].
			 expr := expr eval.
			 echo ifTrue: [StdErr nextPutAll: ' => '; print: expr; cr]].
		file isInteractive ifTrue: [StdErr nextPutAll: '\nmorituri te salutant\n']]].
    StdErr nextPutAll: '; bytes compiled in lamba: '; print: Compiler lambdaCodeSize; cr.
    StdErr nextPutAll: '; bytes reclaimed in eval: '; print: Compiler evalCodeSize; cr.
]
