{ import: VPU5 }

VPU linkageSize		[ VPU missing: 'VPU.linkageSize' ]

VPU allocateFrame	[ VPU missing: 'VPU.allocateFrame' ]

Insn noEmit		[ VPU missing: self debugName, '.emit' ]

VPU missing: which	[ self error: which, ' was not overridden by the platform back-end' ]

" the back-end must override the following "

VPU targetString	[ self missing: 'VPU.targetString' ]
VPU _asmPass		[ self missing: 'VPU._asmPass'	]
VPU _asmPass_: _n	[ self missing: 'VPU._asmPass_: _n' ]
VPU _asmPC		[ self missing: 'VPU._asmPC'	]
VPU _asmPC_: _n		[ self missing: 'VPU._asmPC_: _n'	]

IEnter	emit: vpu [ self noEmit ]
ITmp    emit: vpu [ self noEmit ]
LdFP    emit: vpu [ self noEmit ]
LdInt   emit: vpu [ self noEmit ]
LdPtr   emit: vpu [ self noEmit ]
LdArg   emit: vpu [ self noEmit ]
StArg   emit: vpu [ self noEmit ]
LdTmp   emit: vpu [ self noEmit ]
StTmp   emit: vpu [ self noEmit ]
Dup     emit: vpu [ self noEmit ]
Rdb     emit: vpu [ self noEmit ]
Rdh     emit: vpu [ self noEmit ]
Rdw     emit: vpu [ self noEmit ]
Wrb     emit: vpu [ self noEmit ]
Wrh     emit: vpu [ self noEmit ]
Wrw     emit: vpu [ self noEmit ]
Add     emit: vpu [ self noEmit ]
Sub     emit: vpu [ self noEmit ]
Mul     emit: vpu [ self noEmit ]
Div     emit: vpu [ self noEmit ]
Mod     emit: vpu [ self noEmit ]
And     emit: vpu [ self noEmit ]
Or      emit: vpu [ self noEmit ]
Xor     emit: vpu [ self noEmit ]
Lsl     emit: vpu [ self noEmit ]
Lsr     emit: vpu [ self noEmit ]
Lt      emit: vpu [ self noEmit ]
Le      emit: vpu [ self noEmit ]
Eq      emit: vpu [ self noEmit ]
Ne      emit: vpu [ self noEmit ]
Ge      emit: vpu [ self noEmit ]
Gt      emit: vpu [ self noEmit ]
Br      emit: vpu [ self noEmit ]
Bt      emit: vpu [ self noEmit ]
Bf      emit: vpu [ self noEmit ]
ICall   emit: vpu [ self noEmit ]
ICalli  emit: vpu [ self noEmit ]
Ret     emit: vpu [ self noEmit ]

VPU flush_: _first to_: _last		[ self missing: 'VPU.flush_:to_:']
VPU disassemble_: _first to_: _last	[ self missing: 'VPU.disassemble_:to_:']
