{ import: Object }

ExternalLibrary : Object ()

"----------------------------------------------------------------"

Xlib : ExternalLibrary ()

XSetWindowAttributes : Object ()
XEvent : Object ()
Font : Object ( _display _struct )

X11Display : Object ( _display )

X11Drawable : Object ( display _drawable )
  X11Window : X11Drawable ( _buffer )
  X11Pixmap : X11Drawable ()

X11GC : Object ( drawable _gc )

XSetWindowAttributes : Object ()

XGCValues : Object ()

XEvent : Object ()

{ import: XSetWindowAttributes }
{ import: XGCValues }
{ import: XEvent }
{ import: Font }

{ include <X11/Xlib.h> }
{ include <X11/extensions/Xdbe.h> }

Xlib CopyFromParent	{ return (oop)(CopyFromParent		<< 1 | 1); }

Xlib GCLineWidth	{ return (oop)(GCLineWidth		<< 1 | 1); }
Xlib GCFont		{ return (oop)(GCFont			<< 1 | 1); }

Xlib CWBackPixel	{ return (oop)(CWBackPixel		<< 1 | 1); }
Xlib CWEventMask	{ return (oop)(CWEventMask		<< 1 | 1); }

Xlib KeyPress			{ return (oop)(KeyPress			<< 1 | 1); }
Xlib KeyPressMask		{ return (oop)(KeyPressMask		<< 1 | 1); }
Xlib KeyRelease			{ return (oop)(KeyRelease		<< 1 | 1); }
Xlib KeyReleaseMask		{ return (oop)(KeyReleaseMask		<< 1 | 1); }
Xlib ButtonPress		{ return (oop)(ButtonPress		<< 1 | 1); }
Xlib ButtonPressMask		{ return (oop)(ButtonPressMask		<< 1 | 1); }
Xlib ButtonRelease		{ return (oop)(ButtonRelease		<< 1 | 1); }
Xlib ButtonReleaseMask		{ return (oop)(ButtonReleaseMask	<< 1 | 1); }
Xlib MotionNotify		{ return (oop)(MotionNotify		<< 1 | 1); }
Xlib PointerMotionMask		{ return (oop)(PointerMotionMask	<< 1 | 1); }
Xlib Expose			{ return (oop)(Expose			<< 1 | 1); }
Xlib ExposureMask		{ return (oop)(ExposureMask		<< 1 | 1); }
Xlib ConfigureNotify		{ return (oop)(ConfigureNotify		<< 1 | 1); }
Xlib StructureNotifyMask	{ return (oop)(StructureNotifyMask	<< 1 | 1); }

XlibAllMask := [
    Xlib KeyPressMask
  + Xlib KeyReleaseMask
  + Xlib ButtonPressMask
  + Xlib ButtonReleaseMask
  + Xlib PointerMotionMask
  + Xlib ExposureMask
  + Xlib StructureNotifyMask
]

Xlib AllMask		[ ^XlibAllMask ]

Xlib XdbeUntouched	{ return (oop)(XdbeUntouched	<< 1 | 1); }

DefaultX11Display := []

Xlib XOpenDisplay : _nameString		{ return (oop)XOpenDisplay((char *)v__nameString); }
Xlib DefaultRootWindow : _display	{ return (oop)DefaultRootWindow((Display *)v__display); }

Xlib XCreateWindow : _display : _parent : _x : _y : _w : _h : _b : _d : _class : _visual : _valuemask : attributes
{
    return (oop)XCreateWindow((Display *)v__display, (Window)v__parent,
			      (int)v__x, (int)v__y, (unsigned int)v__w, (unsigned int)v__h, (unsigned int)v__b, (int)v__d,
			      (unsigned int)v__class, (Visual *)v__visual,
			      (unsigned long)v__valuemask, (XSetWindowAttributes *)v_attributes);
}

Xlib XCreateSimpleWindow : _display : _parent : _x : _y : _w : _h : _bw : _bp : _bg
{
    return (oop)XCreateSimpleWindow((Display *)v__display, (Window)v__parent,
				    (int)v__x, (int)v__y, (unsigned int)v__w, (unsigned int)v__h,
				    (unsigned int)v__bw, (unsigned long)v__bp, (unsigned long)v__bg);
}

Xlib CreatePixmap : _display : _parent : _w : _h : _d
{
    return (oop)XCreatePixmap((Display *)v__display, (Window)v__parent, (int)v__w, (int)v__h, (unsigned int)v__d);
}

Xlib XCreateGC : _display : _drawable : _valueMask : _values
{
    return (oop)XCreateGC((Display *)v__display, (Drawable)v__drawable, (unsigned long)v__valueMask, (XGCValues *)v__values);
}

Xlib XMapWindow : _display : _window
{
    return (oop)XMapWindow((Display *)v__display, (Window)v__window);
}

Xlib XUnmapWindow : _display : _window
{
    return (oop)XUnmapWindow((Display *)v__display, (Window)v__window);
}

Xlib XSetWindowBackground : _display : _window : _pixel
{
    return (oop)XSetWindowBackground((Display *)v__display, (Window)v__window, (unsigned long)v__pixel);
}

Xlib XDestroyWindow : _display : _window
{
    return (oop)XDestroyWindow((Display *)v__display, (Window)v__window);
}

Xlib XFreeGC : _display : _gc
{
    return (oop)XFreeGC((Display *)v__display, (GC)v__gc);
}

Xlib XSetForeground : _display : _gc : _pixel
{
    XSetForeground((Display *)v__display, (GC)v__gc, (unsigned long)v__pixel);
}

Xlib XChangeGC : _display : _gc : _mask : _gcvalues
{
    XChangeGC((Display *)v__display, (GC)v__gc, (unsigned long)v__mask, (XGCValues *)v__gcvalues);
}

Xlib XClearArea : _display : _drawable : _x : _y : _w : _h : _exposures
{
    XClearArea((Display *)v__display, (Drawable)v__drawable,
		   (int)v__x, (int)v__y, (unsigned int)v__w,  (unsigned int)v__h, (Bool)v__exposures);
}

Xlib XFillRectangle : _display : _drawable : _gc : _x : _y : _w : _h
{
    XFillRectangle((Display *)v__display, (Drawable)v__drawable, (GC)v__gc,
		   (int)v__x, (int)v__y, (unsigned int)v__w,  (unsigned int)v__h);
}

Xlib XDrawRectangle : _display : _drawable : _gc : _x : _y : _w : _h
{
    XDrawRectangle((Display *)v__display, (Drawable)v__drawable, (GC)v__gc,
		   (int)v__x, (int)v__y, (unsigned int)v__w,  (unsigned int)v__h);
}

Xlib XFillArc : _display : _drawable : _gc : _x : _y : _w : _h : _a1 : _a2
{
    XFillArc((Display *)v__display, (Drawable)v__drawable, (GC)v__gc,
		 (int)v__x, (int)v__y, (unsigned int)v__w,  (unsigned int)v__h, (int)v__a1, (int)v__a2);
}

Xlib XDrawArc : _display : _drawable : _gc : _x : _y : _w : _h : _a1 : _a2
{
    XDrawArc((Display *)v__display, (Drawable)v__drawable, (GC)v__gc,
		 (int)v__x, (int)v__y, (unsigned int)v__w,  (unsigned int)v__h, (int)v__a1, (int)v__a2);
}

Xlib XDrawLine : _display : _drawable : _gc : _x1 : _y1 : _x2 : _y2
{
    XDrawLine((Display *)v__display, (Drawable)v__drawable, (GC)v__gc,
		  (int)v__x1, (int)v__y1, (int)v__x2,  (int)v__y2);
}

Xlib XDrawPoint : _display : _drawable : _gc : _x : _y
{
    XDrawPoint((Display *)v__display, (Drawable)v__drawable, (GC)v__gc, (int)v__x, (int)v__y);
}

Xlib XDrawString : _display : _drawable : _gc : _x : _y : _string : _length
{
    XDrawString((Display *)v__display, (Drawable)v__drawable, (GC)v__gc,
		    (int)v__x, (int)v__y, (char *)v__string, (int)v__length);
}

Xlib XCopyArea : _display : _source : _dest : _gc : _sx : _sy : _w : _h : _dx : _dy
{
    XCopyArea((Display *)v__display, (Drawable)v__source, (Drawable)v__dest, (GC)v__gc,
		  (int)v__sx, (int)v__sy, (int)v__w, (int)v__h, (int)v__dx, (int)v__dy);
}

Xlib XSync : _display
{
    XSync((Display *)v__display, False);
}

Xlib XFlush : _display
{
    XFlush((Display *)v__display);
}

Xlib XGetGeometry_width : _display : _drawable
{
    Window root;
    int x, y;
    unsigned int w, h, b, d;
    XGetGeometry((Display *)v__display, (Drawable)v__drawable, &root, &x, &y, &w, &h, &b, &d);
    return (oop)w;
}

Xlib XGetGeometry_height : _display : _drawable
{
    Window root;
    int x, y;
    unsigned int w, h, b, d;
    XGetGeometry((Display *)v__display, (Drawable)v__drawable, &root, &x, &y, &w, &h, &b, &d);
    return (oop)h;
}

Xlib XGetGeometry_depth : _display : _drawable
{
    Window root;
    int x, y;
    unsigned int w, h, b, d;
    XGetGeometry((Display *)v__display, (Drawable)v__drawable, &root, &x, &y, &w, &h, &b, &d);
    return (oop)d;
}

Xlib XPending : _display
{
    return (oop)!!XPending((Display *)v__display);
}

Xlib XNextEvent : _display : _event
{
    XNextEvent((Display *)v__display, (XEvent *)v__event);
}

Xlib XWindowEvent : _display : _window : _mask : _event
{
    XWindowEvent((Display *)v__display, (Window)v__window, (long)v__mask, (XEvent *)v__event);
}

Xlib XCheckWindowEvent : _display : _window : _mask : _event
{
    return (XCheckWindowEvent((Display *)v__display, (Window)v__window, (long)v__mask, (XEvent *)v__event) == True) ? v_self : 0;
}

Xlib XLoadFont : _display : _name
{
    return (oop)XLoadFont((Display *)v__display, (char *)v__name);
}

Xlib XLoadQueryFont : _display : _name
{
    return (oop)XLoadQueryFont((Display *)v__display, (char *)v__name);
}

Xlib XdbeAllocateBackBufferName : _display : _window : _action
{
    return (oop)XdbeAllocateBackBufferName((Display *)v__display, (Window)v__window, (XdbeSwapAction)(long)v__action);
}

Xlib XdbeBeginIdiom : _display
{
    XdbeBeginIdiom((Display *)v__display);
}

Xlib XdbeEndIdiom : _display
{
    XdbeEndIdiom((Display *)v__display);
}

Xlib XdbeSwapBuffers : _display : _window
{
    XdbeSwapInfo info= { (Window)v__window, XdbeUntouched };
    XdbeSwapBuffers((Display *)v__display, &info, 1);
}

"----------------------------------------------------------------"

X11Display : Object ( _display )

X11Display _display
[
    ^_display
]

X11Display withDisplay_: _aDisplay
[
    self := self new.
    _display := _aDisplay.
]

X11Display open
[
    ^DefaultX11Display isNil
	ifTrue:  [DefaultX11Display := self open: nil]
	ifFalse: [DefaultX11Display]
]

X11Display open: displayName
[
    | _aDisplay |
    _aDisplay := Xlib XOpenDisplay : (displayName isNil ifFalse: [displayName _stringValue]).
    _aDisplay == nil ifTrue: [self error: 'could not open display'].
    ^self withDisplay_: _aDisplay
]

X11Display rootWindow
[
    ^X11Window withDisplay: self drawable_: (Xlib DefaultRootWindow : _display)
]

X11Display sync
[
    ^Xlib XSync : _display
]

X11Display flush
[
    ^Xlib XFlush : _display
]

X11Display nextEvent
[
    | event |
    event := XEvent new.
    Xlib XNextEvent : _display : event.
    ^event
]

X11Display beginDrawing
[
    ^Xlib XdbeBeginIdiom : _display
]

X11Display endDrawing
[
    ^Xlib XdbeEndIdiom : _display
]

X11Display _visual
{
    return (oop)DefaultVisual((Display *)(self->v__display), DefaultScreen((Display *)(self->v__display)));
}

"----------------------------------------------------------------"

X11Drawable : Object ( display _drawable )

X11Drawable display	[ ^display ]
X11Drawable _drawable	[ ^_drawable ]
X11Drawable _buffer	[ ^_drawable ]

X11Drawable _display	[ ^display _display ]
X11Drawable _visual	[ ^display _visual ]

X11Drawable withDisplay: aDisplay drawable_: _aDrawable
[
    self := self new.
    display := aDisplay.
    _drawable := _aDrawable.
]

X11Drawable newGC
[
    ^X11GC
	withDrawable: self
	gc_: (Xlib XCreateGC : display _display : _drawable : nil : nil)
]

X11Window newGC
[
    ^X11GC
	withDrawable: self
	gc_: (Xlib XCreateGC : display _display : _buffer : nil : nil)
]

X11Window withDisplay: aDisplay drawable_: _aDrawable buffer_: _aBuffer
[
    self := super withDisplay: aDisplay drawable_: _aDrawable.
    _buffer := _aBuffer.
]

X11Window newPixmap
[
    ^self newPixmap: self extent
]

X11Window newPixmap: boundingRectangle
[
    ^self newPixmap: boundingRectangle depth: self depth
]

X11Window newPixmap: boundingRectangle depth: depth
[
    ^X11Pixmap withDisplay: display
	       drawable_: (Xlib CreatePixmap : display _display : _buffer
			       : boundingRectangle x _integerValue
			       : boundingRectangle y _integerValue
			       : depth _integerValue)
]

X11Window subWindow: boundingRectangle
[
    | xswa _win |
    xswa := XSetWindowAttributes new.
    xswa eventMask:
	Xlib KeyPressMask | Xlib KeyReleaseMask | Xlib ButtonPressMask | Xlib ButtonReleaseMask | Xlib PointerMotionMask |
	Xlib ExposureMask | Xlib StructureNotifyMask.
    xswa backPixel: 0x000000.
    _win := (Xlib XCreateWindow
		 : display _display : _drawable
		 : boundingRectangle left   _integerValue : boundingRectangle top    _integerValue
		 : boundingRectangle width  _integerValue : boundingRectangle height _integerValue
		 : nil
		 : Xlib CopyFromParent _integerValue
		 : Xlib CopyFromParent _integerValue
		 : Xlib CopyFromParent _integerValue
		 : (Xlib CWEventMask | Xlib CWBackPixel) _integerValue
		 : xswa).
"   ^X11Window withDisplay: display drawable_: _win buffer_: (Xlib XdbeAllocateBackBufferName : display _display : _win : Xlib XdbeUntouched _integerValue)"
    ^X11Window withDisplay: display drawable_: _win buffer_: _win
]

X11Window beDoubleBuffered
[
    _drawable == _buffer
	ifFalse:
	   [_buffer := Xlib XdbeAllocateBackBufferName : display _display : _drawable : Xlib XdbeUntouched _integerValue]
]

X11Window beginDrawing	[ _drawable == _buffer ifFalse: [display beginDrawing] ]
X11Window endDrawing	[ _drawable == _buffer ifFalse: [display endDrawing] ]
X11Window swapBuffers	[ _drawable == _buffer ifFalse: [Xlib XdbeSwapBuffers : display _display : _drawable] ]

X11Window map		[ Xlib XMapWindow     : display _display : _drawable ]
X11Window unmap		[ Xlib XUnmapWindow   : display _display : _drawable ]
X11Window destroy	[ Xlib XDestroyWindow : display _display : _drawable ]

X11Drawable width	[ ^SmallInteger value_: (Xlib XGetGeometry_width  : display _display : _drawable) ]
X11Drawable height	[ ^SmallInteger value_: (Xlib XGetGeometry_height : display _display : _drawable) ]
X11Drawable depth	[ ^SmallInteger value_: (Xlib XGetGeometry_depth  : display _display : _drawable) ]
X11Drawable extent	[ ^self width @ self height ]

X11Drawable clearArea: aRectangle
[
    Xlib XClearArea : display _display : _drawable
	: aRectangle left   _integerValue
	: aRectangle top    _integerValue
	: aRectangle width  _integerValue
	: aRectangle height _integerValue
	: nil
]

X11Window _buffer	[ ^_buffer ]

X11Window background: aPixel
[
    Xlib XSetWindowBackground : display _display : _drawable : aPixel _integerValue
]

X11Window nextEvent
[
    | event |
    event := XEvent new.
    Xlib XWindowEvent : display _display : _drawable : XlibAllMask _integerValue : event.
    ^event
]

X11Window checkEvent
[
    | event |
    event := XEvent new.
    ^(Xlib XCheckWindowEvent : display _display : _drawable : XlibAllMask _integerValue : event) ifTrue: [event]
]

"----------------------------------------------------------------"

X11GC : Object ( drawable _gc )

X11GC drawable	[ ^drawable ]

X11GC withDrawable: aDrawable gc_: _aGC
[
    self := self new.
    drawable := aDrawable.
    _gc      := _aGC.
]

X11GC foreground: aPixel		[ Xlib XSetForeground : drawable display _display : _gc : aPixel _integerValue ]

X11GC changeGC: mask values: gcv	[ Xlib XChangeGC : drawable display _display : _gc : mask _integerValue : gcv ]

X11GC fillRectangle: aRectangle
[
    Xlib XFillRectangle : drawable display _display : drawable _buffer"drawable" : _gc
	: aRectangle left   _integerValue
	: aRectangle top    _integerValue
	: aRectangle width  _integerValue
	: aRectangle height _integerValue
]

X11GC drawRectangle: aRectangle
[
    Xlib XDrawRectangle : drawable display _display : drawable _buffer"drawable" : _gc
	: aRectangle left   _integerValue
	: aRectangle top    _integerValue
	: aRectangle width  _integerValue
	: aRectangle height _integerValue
]

X11GC fillArc: originPoint extent: extentPoint from: startAngle to: endAngle
[
    Xlib XFillArc : drawable display _display : drawable _drawable : _gc
	: originPoint x _integerValue
	: originPoint y _integerValue
	: extentPoint x _integerValue
	: extentPoint y _integerValue
	: startAngle    _integerValue
	: endAngle      _integerValue
]

X11GC drawArc: originPoint extent: extentPoint from: startAngle to: endAngle
[
    Xlib XDrawArc : drawable display _display : drawable _drawable : _gc
	: originPoint x _integerValue
	: originPoint y _integerValue
	: extentPoint x _integerValue
	: extentPoint y _integerValue
	: startAngle    _integerValue
	: endAngle      _integerValue
]

X11GC drawLine: startPoint to: endPoint
[
    Xlib XDrawLine : drawable display _display : drawable _drawable : _gc
	: startPoint x _integerValue
	: startPoint y _integerValue
	: endPoint   x _integerValue
	: endPoint   y _integerValue
]

X11GC drawPoint: aPoint
[
    Xlib XDrawPoint : drawable display _display : drawable _drawable : _gc
	: aPoint x _integerValue
	: aPoint y _integerValue
]

X11GC drawString: aString at: aPoint
[
    Xlib XDrawString : drawable display _display : drawable _buffer"drawable" : _gc
	: aPoint x _integerValue
	: aPoint y _integerValue
	: aString  _stringValue
	: aString  size _integerValue
]

X11GC copyArea: sourceDrawable to: destDrawable from: sourceOrigin extent: extent to: destOrigin
[
    Xlib XCopyArea : drawable display _display : sourceDrawable _buffer"drawable" : destDrawable _drawable : _gc
	: sourceOrigin x _integerValue : sourceOrigin y _integerValue
	: extent       x _integerValue : extent       y _integerValue
	: destOrigin   x _integerValue : destOrigin   y _integerValue
]

X11GC free	[ Xlib XFreeGC : drawable display _display : _gc ]
