{ import: Thread }

MyThread : Thread ( start stop )

MyThread from: startNumber to: stopNumber
[
    self  := self new.
    start := startNumber.
    stop  := stopNumber.
]

MyThread run
[
    StdOut nextPutAll: 'MyThread running\n'.
    start to: stop do: [:i |
	StdOut print: i; cr.
	OS usleep: 100000]
]

[
    | t1 t2 |
    t1 := MyThread from: 10 to: 20.
    t2 := MyThread from: 20 to: 30.
    t1 resume.
    OS usleep: 50000.
    t2 resume.
    t1 join.
    t2 join.
]

"----------------------------------------------------------------"

{ import: Process }

MyProcess : Process ( start stop )

MyProcess from: startNumber to: stopNumber
[
    self  := self new.
    start := startNumber.
    stop  := stopNumber.
]

MyProcess run
[
    StdOut nextPutAll: 'MyProcess running\n'.
    start to: stop do: [:i |
	StdOut print: i; cr.
	OS usleep: 100000]
]

[
    | p1 p2 |
    p1 := MyProcess from: 10 to: 20.
    p2 := MyProcess from: 20 to: 30.
    p1 resume.
    OS usleep: 50000.
    p2 resume.
    p1 join.
    p2 join.
]
