{ import: st80 }

FileName : Object ( name parent )

DirectoryName : FileName ( entries )

DirectoryName withName: nameString parent: parentDirectory
[
    self := self new.
    name := nameString.
    parent := parentDirectory.
]

DirectoryName root
[
    ^self withName: '/' parent: nil
]

DirectoryName forPath: pathString
[
    ^self forComponents: (pathString tokenized: '/')
]

DirectoryName forComponents: pathComponents
[
    ^pathComponents inject: self root into: [:parentDirectory :nameString | self withName: nameString parent: parentDirectory]
]

DirectoryName printOn: aStream
[
    parent isNil ifFalse: [parent printOn: aStream.  aStream nextPut: $/].
    aStream nextPutAll: name
]

[
    (DirectoryName forPath: '/Users') printString println.
]
