{ import: testa } [ TestA put ]
{ import: testd } [ TestD put ]
{ import: testc } [ TestC put ]
{ import: testb } [ TestB put ]
{ import: teste } [ TestE put ] [ $\n put ]

Object assert []

UndefinedObject assert
[
    'assertion failed' putln.
    { exit(1); }.
]

Object block10	[ ^[] ]
Object block11 	[ ^[42] ]
Object block12 	[ ^[[42]] ]
Object block13 	[ ^[self] ]
Object block14 	[ ^[[self]] ]

Object block15: n [ ^[n := n + 1] ]

Foo : Object ( x )
Foo x [ ^x ]
Foo block16 [ ^[:a | x := a] ]
Foo block17 [ ^[x] ]

[
    | x b |
    x := 42.

    $A put.

    0 print.	(nil == nil) assert.
    0 print.	([] value == nil) assert.
    0 print.	([x] value == 42) assert.

    1 print.	(nil block10 value == nil) assert.
    1 print.	(nil block11 value == 42) assert.
    1 print.	(nil block12 value value == 42) assert.

    2 print.	(Object block13 value == Object) assert.
    2 print.	(nil    block13 value == nil   ) assert.
    2 print.	(42     block13 value == 42    ) assert.

    3 print.	(Object block14 value value == Object) assert.
    3 print.	(nil    block14 value value == nil   ) assert.
    3 print.	(42     block14 value value == 42    ) assert.

    4 print.	([| y | y := 666.    [[:z | y := z]]   value.            	     y] value == 666) assert.
    4 print.	([| y | y := 666.    [[:z | y := z]]   value value: 42. 	     y] value == 42 ) assert.
    4 print.	([| y | y := 666.  [[[[:z | y := z]]]] value.        	   	     y] value == 666) assert.
    4 print.	([| y | y := 666.  [[[[:z | y := z]]]] value value.  	   	     y] value == 666) assert.
    4 print.	([| y | y := 666.  [[[[:z | y := z]]]] value value value.  	     y] value == 666) assert.
    4 print.	([| y | y := 666.  [[[[:z | y := z]]]] value value value value: 42.  y] value == 42 ) assert.

    5 print.	(([:y |   [[:z | y := z]]   value.            	   	  y] value: 111) == 111) assert.
    5 print.	(([:y |   [[:z | y := z]]   value value: 42.  	   	  y] value: 222) == 42 ) assert.
    5 print.	(([:y | [[[[:z | y := z]]]] value.        	   	  y] value: 333) == 333) assert.
    5 print.	(([:y | [[[[:z | y := z]]]] value value.  	   	  y] value: 444) == 444) assert.
    5 print.	(([:y | [[[[:z | y := z]]]] value value value.  	  y] value: 555) == 555) assert.
    5 print.	(([:y | [[[[:z | y := z]]]] value value value value: 42.  y] value: 666) == 42 ) assert.

    b := [:n | [n := n + 1]] value: 40.

    6 print.	(b value == 41) assert.
    6 print.	(b value == 42) assert.
    6 print.	(b value == 43) assert.

    b := Object block15: 664.

    7 print.	(b value == 665) assert.
    7 print.	(b value == 666) assert.
    7 print.	(b value == 667) assert.

    x := Foo new.

    8 print.	(x x == nil) assert.
    x block16 value: 42.
    8 print.	(x x == 42) assert.
    8 print.	((x block17 value) == 42) assert.
    x block16 value: 666.
    8 print.	(x x == 666) assert.
    8 print.	((x block17 value) == 666) assert.

    $\n put.
]

Object block20: x with: y [ [:p |  p] value: x.  ^y ]
Object block21: x with: y [ [:p | ^p] value: x.  ^y ]

[
    $B put.

    1 print.	((Object block20: 42 with: 666) == 666) assert.
    1 print.	((Object block21: 42 with: 666) == 42 ) assert.

    $\n put.
]

Object ifTrue:  aBlock			[ ^aBlock value ]
Object ifFalse: aBlock			[ ^nil ]
Object ifTrue:  aBlock ifFalse: bBlock	[ ^aBlock value ]
Object ifFalse: aBlock ifTrue:  bBlock	[ ^bBlock value ]

UndefinedObject ifTrue:  aBlock			[ ^nil ]
UndefinedObject ifFalse: aBlock			[ ^aBlock value ]
UndefinedObject ifTrue:  aBlock ifFalse: bBlock	[ ^bBlock value ]
UndefinedObject ifFalse: aBlock ifTrue:  bBlock	[ ^aBlock value ]

BlockClosure whileTrue		[ self value ifTrue:  [self whileTrue] ]
BlockClosure whileFalse		[ self value ifFalse: [self whileTrue] ]
BlockClosure whileTrue: aBlock	[ self value ifTrue:  [aBlock value. self whileTrue:  aBlock] ]
BlockClosure whileFalse: aBlock	[ self value ifFalse: [aBlock value. self whileFalse: aBlock] ]

SmallInteger * aNumber
[
    { if ((int)v_aNumber & 1) return (oop)(((((int)v_self >> 1) * ((int)v_aNumber >> 1)) << 1) | 1); }.
    ^super * aNumber
]

SmallInteger // aNumber
[
    { if ((int)v_aNumber & 1) return (oop)(((((int)v_self >> 1) / ((int)v_aNumber >> 1)) << 1) | 1); }.
    ^super // aNumber
]

SmallInteger \\ aNumber
[
    { if ((int)v_aNumber & 1) return (oop)(((((int)v_self >> 1) % ((int)v_aNumber >> 1)) << 1) | 1); }.
    ^super \\ aNumber
]

SmallInteger <= aNumber
[
    { if ((int)v_aNumber & 1) return ((int)v_self <= (int)v_aNumber) ? v_true : v_false; }.
    ^super <= aNumber
]

SmallInteger = aNumber
[
    { if ((int)v_aNumber & 1) return ((int)v_self == (int)v_aNumber) ? v_true : v_false; }.
    ^super = aNumber
]

SmallInteger ~= aNumber
[
    { if ((int)v_aNumber & 1) return ((int)v_self != (int)v_aNumber) ? v_true : v_false; }.
    ^super ~= aNumber
]

SmallInteger >= aNumber
[
    { if ((int)v_aNumber & 1) return ((int)v_self >= (int)v_aNumber) ? v_true : v_false; }.
    ^super >= aNumber
]

SmallInteger > aNumber
[
    { if ((int)v_aNumber & 1) return ((int)v_self > (int)v_aNumber) ? v_true : v_false; }.
    ^super > aNumber
]

SmallInteger bitAnd: aNumber
[
    { if ((int)v_aNumber & 1) return (oop)((int)v_self & (int)v_aNumber); }.
    ^super * aNumber
]

SmallInteger bitOr: aNumber
[
    { if ((int)v_aNumber & 1) return (oop)((int)v_self | (int)v_aNumber); }.
    ^super * aNumber
]

SmallInteger bitXor: aNumber
[
    { if ((int)v_aNumber & 1) return (oop)(((int)v_self ^ (int)v_aNumber) | 1); }.
    ^super * aNumber
]

SmallInteger bitShift: aNumber
[
    { if ((int)v_aNumber & 1) return
	(oop)(((((int)v_aNumber < 0)
		    ? (((int)v_self >> 1) >> -((int)v_aNumber >> 1))
		    : (((int)v_self >> 1) <<  ((int)v_aNumber >> 1))) << 1) | 1); }.
    ^super bitShift: aNumber
]

SmallInteger << aNumber
[
    { if ((int)v_aNumber & 1) return (oop)(((((int)v_self >> 1) << ((int)v_aNumber >> 1)) << 1) | 1); }.
    ^super << aNumber
]

SmallInteger >> aNumber
[
    { if ((int)v_aNumber & 1) return (oop)(((((int)v_self >> 1) >> ((int)v_aNumber >> 1)) << 1) | 1); }.
    ^super >> aNumber
]

[
    | a b |
    $C put.

    a := 41.
    b := 625.

    1 print.	(0 + 0 == 0) assert.
    1 print.	(0 + 1 == 1) assert.
    1 print.	(1 + 0 == 1) assert.
    1 print.	(1 + 1 == 2) assert.

    2 print.	(1 + a == 42 ) assert.
    2 print.	(a + 1 == 42 ) assert.
    2 print.	(a + b == 666) assert.

    a := 21.
    b := 2.

    3 print.	(0 * a == 0 ) assert.
    3 print.	(1 * a == 21) assert.
    3 print.	(2 * a == 42) assert.
    3 print.	(a * 0 == 0 ) assert.
    3 print.	(a * 1 == 21) assert.
    3 print.	(a * 2 == 42) assert.
    3 print.	(a * b == 42) assert.

    4 print.	(84 // 2 == 42) assert.
    4 print.	(42 // a == 2 ) assert.
    4 print.	(a  // 7 == 3 ) assert.
    4 print.	(a  // b == 10) assert.

    5 print.	(21 \\ 3 == 0) assert.
    5 print.	(22 \\ 3 == 1) assert.
    5 print.	(23 \\ 3 == 2) assert.
    5 print.	(24 \\ 3 == 0) assert.

    6 print.	((a + 0) \\ 3 == 0) assert.
    6 print.	((a + 1) \\ 3 == 1) assert.
    6 print.	((a + 2) \\ 3 == 2) assert.
    6 print.	((a + 3) \\ 3 == 0) assert.

    b := 3.

    7 print.	(21 \\ b == 0) assert.
    7 print.	(22 \\ b == 1) assert.
    7 print.	(23 \\ b == 2) assert.
    7 print.	(24 \\ b == 0) assert.

    8 print.	((a + 0) \\ b == 0) assert.
    8 print.	((a + 1) \\ b == 1) assert.
    8 print.	((a + 2) \\ b == 2) assert.
    8 print.	((a + 3) \\ b == 0) assert.

    $\n put.
]

Object		not [ ^nil ]
UndefinedObject	not [ ^Object ]

[
    | zero one two |
    $D put.

    zero := 0.
    one  := 1.
    two  := 2.

    0 print.	(1    <     0) not assert.
    0 print.	(1    <     1) not assert.
    0 print.	(1    <     2)     assert.
    0 print.	(1    <  zero) not assert.
    0 print.	(1    <   one) not assert.
    0 print.	(1    <   two)     assert.
    0 print.	(one  <     0) not assert.
    0 print.	(one  <     1) not assert.
    0 print.	(one  <     2)     assert.
    0 print.	(one  <  zero) not assert.
    0 print.	(one  <   one) not assert.
    0 print.	(one  <   two)     assert.

    1 print.	(1    <=    0) not assert.
    1 print.	(1    <=    1)     assert.
    1 print.	(1    <=    2)     assert.
    1 print.	(1    <= zero) not assert.
    1 print.	(1    <=  one)     assert.
    1 print.	(1    <=  two)     assert.
    1 print.	(one  <=    0) not assert.
    1 print.	(one  <=    1)     assert.
    1 print.	(one  <=    2)     assert.
    1 print.	(one  <= zero) not assert.
    1 print.	(one  <=  one)     assert.
    1 print.	(one  <=  two)     assert.

    2 print.	(1    =     0) not assert.
    2 print.	(1    =     1)     assert.
    2 print.	(1    =     2) not assert.
    2 print.	(1    =  zero) not assert.
    2 print.	(1    =   one)     assert.
    2 print.	(1    =   two) not assert.
    2 print.	(one  =     0) not assert.
    2 print.	(one  =     1)     assert.
    2 print.	(one  =     2) not assert.
    2 print.	(one  =  zero) not assert.
    2 print.	(one  =   one)     assert.
    2 print.	(one  =   two) not assert.

    3 print.	(1    ~=    0)     assert.
    3 print.	(1    ~=    1) not assert.
    3 print.	(1    ~=    2)     assert.
    3 print.	(1    ~= zero)     assert.
    3 print.	(1    ~=  one) not assert.
    3 print.	(1    ~=  two)     assert.
    3 print.	(one  ~=    0)     assert.
    3 print.	(one  ~=    1) not assert.
    3 print.	(one  ~=    2)     assert.
    3 print.	(one  ~= zero)     assert.
    3 print.	(one  ~=  one) not assert.
    3 print.	(one  ~=  two)     assert.

    4 print.	(1    >=    0)     assert.
    4 print.	(1    >=    1)     assert.
    4 print.	(1    >=    2) not assert.
    4 print.	(1    >= zero)     assert.
    4 print.	(1    >=  one)     assert.
    4 print.	(1    >=  two) not assert.
    4 print.	(one  >=    0)     assert.
    4 print.	(one  >=    1)     assert.
    4 print.	(one  >=    2) not assert.
    4 print.	(one  >= zero)     assert.
    4 print.	(one  >=  one)     assert.
    4 print.	(one  >=  two) not assert.

    5 print.	(1    >     0)     assert.
    5 print.	(1    >     1) not assert.
    5 print.	(1    >     2) not assert.
    5 print.	(1    >  zero)     assert.
    5 print.	(1    >   one) not assert.
    5 print.	(1    >   two) not assert.
    5 print.	(one  >     0)     assert.
    5 print.	(one  >     1) not assert.
    5 print.	(one  >     2) not assert.
    5 print.	(one  >  zero)     assert.
    5 print.	(one  >   one) not assert.
    5 print.	(one  >   two) not assert.

    $\n put.
]

SmallInteger timesRepeat: aBlock
[
    | count |
    count := self.
    [0 < count]
	whileTrue:
	   [aBlock value.
	    count := count - 1].
]

[
    | x |
    $E put.

    1 print.	((true  ifTrue:  [1]) == 1  ) assert.
    1 print.	((true  ifFalse: [1]) == nil) assert.
    1 print.	((false ifTrue:  [1]) == nil) assert.
    1 print.	((false ifFalse: [1]) == 1  ) assert.

    2 print.	((true  ifTrue:  [1] ifFalse: [2]) == 1) assert.
    2 print.	((true  ifFalse: [1] ifTrue:  [2]) == 2) assert.
    2 print.	((false ifTrue:  [1] ifFalse: [2]) == 2) assert.
    2 print.	((false ifFalse: [1] ifTrue:  [2]) == 1) assert.

    x := 2.
    [(x := x + 1) print < 10] whileTrue.
    x := 100.
    [(x := x + 1) < 110] whileTrue: [x print].

    x := 200.
    10 timesRepeat: [x := x print + 1].

    $\n put.
]

[
    | m n o five six |
    $F put.

    m := -1.
    n :=  0.
    o :=  1.
    five  := 5.
    six   := 6.

    1 print.	((5    bitAnd: 6  ) == 4) assert.
    1 print.	((five bitAnd: 6  ) == 4) assert.
    1 print.	((5    bitAnd: six) == 4) assert.
    1 print.	((five bitAnd: six) == 4) assert.

    2 print.	((5    bitOr:  6  ) == 7) assert.
    2 print.	((five bitOr:  6  ) == 7) assert.
    2 print.	((5    bitOr:  six) == 7) assert.
    2 print.	((five bitOr:  six) == 7) assert.

    3 print.	((5    bitXor: 6  ) == 3) assert.
    3 print.	((five bitXor: 6  ) == 3) assert.
    3 print.	((5    bitXor: six) == 3) assert.
    3 print.	((five bitXor: six) == 3) assert.

    4 print.	((5    bitShift: -1) ==	 2) assert.
    4 print.	((5    bitShift:  0) ==	 5) assert.
    4 print.	((5    bitShift:  1) ==	10) assert.
    4 print.	((5    bitShift:  m) ==	 2) assert.
    4 print.	((5    bitShift:  n) ==	 5) assert.
    4 print.	((5    bitShift:  o) ==	10) assert.
    4 print.	((five bitShift: -1) ==	 2) assert.
    4 print.	((five bitShift:  0) ==	 5) assert.
    4 print.	((five bitShift:  1) ==	10) assert.
    4 print.	((five bitShift:  m) ==	 2) assert.
    4 print.	((five bitShift:  n) ==	 5) assert.
    4 print.	((five bitShift:  o) ==	10) assert.

    5 print.	((5    << 0) ==	 5) assert.
    5 print.	((5    << 1) ==	10) assert.
    5 print.	((5    << n) ==	 5) assert.
    5 print.	((5    << o) ==	10) assert.
    5 print.	((five << 0) ==	 5) assert.
    5 print.	((five << 1) ==	10) assert.
    5 print.	((five << n) ==	 5) assert.
    5 print.	((five << o) ==	10) assert.

    6 print.	((5    >> 0) ==	 5) assert.
    6 print.	((5    >> 1) ==	 2) assert.
    6 print.	((5    >> n) ==	 5) assert.
    6 print.	((5    >> o) ==	 2) assert.
    6 print.	((five >> 0) ==	 5) assert.
    6 print.	((five >> 1) ==	 2) assert.
    6 print.	((five >> n) ==	 5) assert.
    6 print.	((five >> o) ==	 2) assert.

    $\n put.
]

Symbol : Object ()			{ pragma: type symbol Symbol }

Symbol size_: _size value_: _value
{
  return _selector((char *)v__value);
}

_selector == aSelector	{ return (v_self == v_aSelector) ? v_true : v_false; }

[
    $G put.

    1 print.    (#hello == #hello) assert.
    1 print.    (#hello == #hello) assert.
    1 print.    (#hello == #goodbye) not assert.
    1 print.    (#goodbye == #goodbye) assert.

    $\n put.
]


ArrayedCollection : Object ( size _elements )

ArrayedCollection size_: _size value_: _contents
[
    self := self new.
    size := SmallInteger value_: _size.
    _elements := _contents.
]

ArrayedCollection size	[ ^size ]

ByteArray : ArrayedCollection ()	{ pragma: type byteArray ByteArray }

ByteArray isByteArray	[ ^true ]
Object    isByteArray	[ ^false ]

ByteArray byteAt: index
[
    {
      if (((int)v_index > ((0<<1)|1)) && ((int)v_index <= (int)(self->v_size)))
        return (oop)(((((char *)(self->v__elements))[((int)v_index >> 1) - 1]) << 1) | 1);
    }.
    ^self primitiveFailed.
]

ByteArray at: index	[ ^self byteAt: index ]

WordArray : ArrayedCollection ()	{ pragma: type wordArray WordArray }

WordArray isWordArray	[ ^true ]
Object    isWordArray	[ ^false ]

WordArray wordAt: index
[
    {
      if (((int)v_index > ((0<<1)|1)) && ((int)v_index <= (int)(self->v_size)))
        return (oop)(((((int *)(self->v__elements))[((int)v_index >> 1) - 1]) << 1) | 1);
    }.
    ^self primitiveFailed.
]

WordArray at: index	[ ^self wordAt: index ]

Array : ArrayedCollection ()		{ pragma: type objectArray Array }

Array isArray	[ ^true ]
Object isArray	[ ^false ]

Array size_: _size value_: _contents
[
    self := super size_: _size value_: _contents.
    {
      oop  *elements= (oop *)(self->v__elements);
      int i, j= (int)v__size;
      for (i= 0;  i < j;  ++i)
        elements[i]= *(((oop **)elements)[i]);
    }.
]

Array at: index
[
    {
      if (((int)v_index > ((0<<1)|1)) && ((int)v_index <= (int)(self->v_size)))
        return ((oop *)(self->v__elements))[((int)v_index >> 1) - 1];
    }.
    ^self primitiveFailed.
]

[
    $H put.

    1 print.	(#[] isByteArray) assert.
    1 print.	(#[] size == 0) assert.
    1 print.	(#[] == #[]) assert.
    1 print.	(#[1 2 3] size == 3) assert.
    1 print.	(#[1 2 3] == #[1 2 3]) assert.
    1 print.	(#[1 2 3] == #[4 5 6]) not assert.
    1 print.	(#[4 5 6] == #[4 5 6]) assert.
    1 print.	((#[4 5 6] at: 1) == 4) assert.
    1 print.	((#[4 5 6] at: 2) == 5) assert.
    1 print.	((#[4 5 6] at: 3) == 6) assert.

    2 print.	(#{} isWordArray) assert.
    2 print.	(#{} size == 0) assert.
    2 print.	(#{} == #{}) assert.
    2 print.	(#{} == #[]) not assert.
    2 print.	(#{1 2 3} size == 3) assert.
    2 print.	(#{1 2 3} == #{1 2 3}) assert.
    2 print.	(#{1 2 3} == #{4 5 6}) not assert.
    2 print.	(#{4 5 6} == #{4 5 6}) assert.
    2 print.	((#{4 5 6} at: 1) == 4) assert.
    2 print.	((#{4 5 6} at: 2) == 5) assert.
    2 print.	((#{4 5 6} at: 3) == 6) assert.

    3 print.	(#() isArray) assert.
    3 print.	(#() size == 0) assert.
    3 print.	(#() == #()) assert.
    3 print.	(#() == #[]) not assert.
    3 print.	(#() == #{}) not assert.

    3 print.	(#(1 two 3) size == 3) assert.
    3 print.	(#(1 two 3) == #(1 two 3)) assert.
    3 print.	(#(1 two 3) == #(4 five 6)) not assert.
    3 print.	(#(4 five 6) == #(4 five 6)) assert.

    4 print.	((#(4 five 6) at: 1) == 4) assert.
    4 print.	((#(4 five 6) at: 2) == #five) assert.
    4 print.	((#(4 five 6) at: 3) == 6) assert.

    5 print.	(  #(4 (1 two 3) 6) size == 3) assert.
    5 print.	( (#(4 (1 two 3) 6) at: 1) == 4) assert.
    5 print.	( (#(4 (1 two 3) 6) at: 2) == #(1 two 3)) assert.
    5 print.	( (#(4 (1 two 3) 6) at: 3) == 6) assert.

    6 print.	(((#(4 (1 two 3) 6) at: 2) at: 1) == 1) assert.
    6 print.	(((#(4 (1 two 3) 6) at: 2) at: 2) == #two) assert.
    6 print.	(((#(4 (1 two 3) 6) at: 2) at: 3) == 3) assert.

    7 print.	( (#(4 #[1 2 3] 6) at: 2) == #[1 2 3]) assert.
    7 print.	( (#(4 #{1 2 3} 6) at: 2) == #{1 2 3}) assert.

    $\n put.
]

[
    'success' putln.
]



Time : Object ()

Time millisecondClockValue
[
    | ms |
    {
      struct timeval tv;
      gettimeofday(&tv, 0);
      v_ms= (oop)((((tv.tv_sec * 1000 + tv.tv_usec / 1000) & 0x3fffffff) << 1) | 1);
    }.
    ^ms
]

Time millisecondsToRun: timedBlock
[
    | initialClockValue |
    initialClockValue := self millisecondClockValue.
    timedBlock value.
    ^self millisecondClockValue - initialClockValue
]

Array new: newSize
[
    self := self new.
    size := newSize.
    { ((struct t_Array *)v_self)->v__elements= (oop)_palloc(sizeof(oop) * ((int)v_newSize >> 1)); }.
]

SmallInteger to: limit do: unaryBlock
[
    | induct |
    induct := self.
    [induct < limit]
	whileTrue:
	   [unaryBlock value: induct.
	    induct := induct + 1].
]

Array at: index put: anObject
[
    {
      if (((int)v_index > ((0<<1)|1)) && ((int)v_index <= (int)(self->v_size)))
        return ((oop *)(self->v__elements))[((int)v_index >> 1) - 1]= v_anObject;
    }.
    ^self primitiveFailed.
]

Array atAllPut: anObject
[
    1 to: self size do: [:index | self at: index put: anObject].
]

"Results in comments are for the Squeak VM, not for id."

SmallInteger benchFib
[
    "(result // seconds to run) = approx calls per second"
    "138000 on a Mac 8100/100"
    ^self < 2
	ifTrue:  [1] 
	ifFalse: [(self - 1) benchFib + (self - 2) benchFib + 1].
]

SmallInteger benchmark
[
    "(500000 // time to run) = approx bytecodes per second"
    "3059000 on a Mac 8100/100"
    | size flags prime k count |
    size := 8190.
    1 to: self do:
       [:iter |
        count := 0.
        flags := (Array new: size + 1) atAllPut: true.
	1 to: size do:
	   [:i |
            (flags at: i) ifTrue:
	       [prime := i + 1.
                k := i + prime.
		[k <= size] whileTrue:
		   [flags at: k put: false.
                    k := k + prime].
		count := count + 1]]].
    ^count.
]

SmallInteger tinyBenchmarks
[
    "Report the results of running the two tiny Squeak benchmarks."
    "On a 292 MHz G3 Mac: 22727272 bytecodes/sec; 984169 sends/sec"
    "On a 400 MHz PII/Win98:  18028169 bytecodes/sec; 1081272 sends/sec"
    | t1 t2 r n1 n2 |
    n1 := 1.
    [t1 := Time millisecondsToRun: [r := n1 benchmark].
    t1 < 1000] whileTrue:[n1 := n1 * 2].
""
    r print.  ' primes in ' put.  t1 print.  'ms for ' put.  n1 print.  ' iterations' putln.
""
    n2 := 28.
    [(t2 := Time millisecondsToRun: [r := n2 benchFib]) < 1000]
        whileTrue: [n2 := n2 + 1].
""
    r print.  ' nfibs in ' put.  t2 print.  'ms for ' put.  n2 print.  ' iterations' putln.
""
    (500000 // t1 * n1 * 1000) print.  ' bytecodes/sec; ' put.
    (r // t2 * 1000) print.  ' sends/sec' putln.
]

[
    0 tinyBenchmarks
]
