{ import: _object }

Object : _object ()					[ Object := _object ]	"alias"
  UndefinedObject : Object ()
  SmallInteger : Object ()
  Symbol : Object ( _size _elements )			[ Symbol := _selector ]	"alias"
  Collection : Object ()
    SequenceableCollection : Collection ()
      ArrayedCollection : SequenceableCollection ( size )
        Array : ArrayedCollection ( _oops )
        ByteArray : ArrayedCollection ( _bytes )
          String : ByteArray ()
      OrderedCollection : SequenceableCollection ( firstIndex lastIndex array )
    IdentitySet : Collection ( tally lists )
      IdentityDictionary : IdentitySet ()
        FastIdentityDictionary : IdentityDictionary ()
  StaticBlockClosure : Object ( _function _arity )
    BlockClosure : StaticBlockClosure ( outer state _nlr )
  SinkStream : Object ()
  ReadStream : Object ( collection position readLimit )
    WriteStream : ReadStream ( writeLimit )
    FileStream : ReadStream ( file )
    ConsoleFileStream : FileStream ( prompt )

nil   : UndefinedObject ()
true  : Object ()
false : Object ()

{ pragma: type nil   nil   }
{ pragma: type true  true  }
{ pragma: type false false }

{ pragma: type integer   SmallInteger }
{ pragma: type character SmallInteger }

{ pragma: type byteArray ByteArray }
{ pragma: type string String }

{ pragma: type symbol Symbol }
{ pragma: type objectArray Array }
{ pragma: type staticClosure StaticBlockClosure }
{ pragma: type fullClosure BlockClosure }

StdIn  := []
StdOut := []
StdErr := []
