// VPU-1 compatibility (for old YNVMs)

enum { Debug= -1, DumpFinalCode= 1 };

int nTemps;

VPU *VPU::Begin(int n);
VPU *VPU::Define(int n);
VPU *VPU::End(int n);
VPU *VPU::Define(Label &l);
VPU *VPU::Define(Label *l);
VPU *VPU::Enter(int n= 0);
VPU *VPU::PushTemps(int n);
VPU *VPU::PopTemps(int n);
VPU *VPU::LdFP(void);
VPU *VPU::LdArg(int n);
VPU *VPU::StArg(int n);
VPU *VPU::LdTemp(int n);
VPU *VPU::StTemp(int n);
VPU *VPU::Ld(void *p);
VPU *VPU::St(void *p);
VPU *VPU::LdInt(int i);
VPU *VPU::Dup(void);
VPU *VPU::Pop(void);
VPU *VPU::Lt(void);
VPU *VPU::Le(void);
VPU *VPU::Eq(void);
VPU *VPU::Ne(void);
VPU *VPU::Ge(void);
VPU *VPU::Gt(void);
VPU *VPU::Bf(int n);
VPU *VPU::Bt(int n);
VPU *VPU::Br(int n);
VPU *VPU::Call(int n, void *f);
VPU *VPU::Call(int n, Label *l);
VPU *VPU::Call(int n);
VPU *VPU::Return(void);
VPU *VPU::Add(void);
VPU *VPU::Sub(void);
VPU *VPU::Mul(void);
VPU *VPU::Div(void);
VPU *VPU::Mod(void);
VPU *VPU::And(void);
VPU *VPU::Or (void);
VPU *VPU::Xor(void);
VPU *VPU::Asl(void);
VPU *VPU::Asr(void);
VPU *VPU::Rdb(void);
VPU *VPU::Rdh(void);
VPU *VPU::Rdw(void);
VPU *VPU::Wrb(void);
VPU *VPU::Wrh(void);
VPU *VPU::Wrw(void);
