{ import: glui }

GLWindow : Object ( id )

GLWindow new
[
    self := super new.
    id := GLUT createWindow: 'Untitled' bounds: (100@100 extent: 200@200)
]

GLWindow display
[
    self
	clear: self glColorBufferBit;
	color: Color red;   rect:  ( 25@25 corner: 125@125);
	color: Color green; rect:  (125@25 corner: 225@125);
	color: Color blue;  rect:  (225@25 corner: 325@125);
	color: Color black;
	rasterPos: 100@75;
	drawString: 'Press ESCAPE to exit' font: self glutBitmapHelvetica18;
	flush.
]

GLWindow reshape: width with: height
[
    self
	viewport: (0@0 corner: width@height);
	matrixMode: self glProjection;
	loadIdentity;
	ortho: (0@0@-1 corner: width@height@0).
]

GLWindow keyboard: key with: x with: y
[
    key == 27 ifTrue: [Smalltalk quit].
]


[
    GLWindow new mainLoop.		"withBounds: (100@100 extent: 350@150) labeled: 'Hello from OpenGL'"
]
