{ import: VPU5 }

{ include <udis86.h> }

VPU disassemble_: _first to_: _last
{
    size_t size= (size_t)v__last - (size_t)v__first;
    int n= 0;
    unsigned char *pc= (unsigned char *)v__first;
    ud_t ud_obj;

    ud_init(&ud_obj);
    ud_set_input_buffer(&ud_obj, pc, size);
    ud_set_mode(&ud_obj, 32);
    ud_set_syntax(&ud_obj, UD_SYN_ATT);
    ud_set_pc(&ud_obj, (uint64_t)(long)v__first);

    while ((size > 0) && (n= ud_disassemble(&ud_obj)))
    {
      char buf[64];
      sprintf(buf, "%08lx %s\n", (unsigned long)pc, ud_insn_asm(&ud_obj));
      write(1, buf, strlen(buf));
      pc += n;
      size -= n;
    }
}
