{ import: Xlib }

{ include <X11/Xlib.h> }
{ include <X11/Xutil.h> }

XEvent _sizeof	{ return (oop)sizeof(XEvent); }

XEvent type		{ return (oop)((((XEvent       	  *)self)->type   ) << 1 | 1); }
XEvent x		{ return (oop)((((XMotionEvent 	  *)self)->x      ) << 1 | 1); }
XEvent y		{ return (oop)((((XMotionEvent 	  *)self)->y      ) << 1 | 1); }
XEvent state		{ return (oop)((((XKeyEvent    	  *)self)->state  ) << 1 | 1); }
XEvent button		{ return (oop)((((XButtonEvent 	  *)self)->button ) << 1 | 1); }
XEvent width		{ return (oop)((((XConfigureEvent *)self)->width  ) << 1 | 1); }
XEvent height		{ return (oop)((((XConfigureEvent *)self)->height ) << 1 | 1); }

XEvent keyCode
{
    char buffer[32];
    KeySym keySym;
    static XComposeStatus status;
    if (XLookupString((XKeyEvent *)self, buffer, sizeof(buffer), &keySym, &status))
        return (oop)(buffer[0] << 1 | 1);
    switch (keySym)
    {
	case 0xff51 /* left  */	: return (oop)(17 << 1 | 1);
	case 0xff52 /* up    */	: return (oop)(30 << 1 | 1);
	case 0xff53 /* right */	: return (oop)(16 << 1 | 1);
	case 0xff54 /* down  */	: return (oop)(31 << 1 | 1);
    }
    return 0;
}

XEvent position		[ ^self x @ self y ]

XEvent isKeyPress	[ ^self type == Xlib KeyPress ]
XEvent isKeyRelease	[ ^self type == Xlib KeyRelease ]
XEvent isButtonPress	[ ^self type == Xlib ButtonPress ]
XEvent isButtonRelease	[ ^self type == Xlib ButtonRelease ]
XEvent isMotionNotify	[ ^self type == Xlib MotionNotify ]
XEvent isExpose		[ ^self type == Xlib Expose ]

"
1 = White happy face
2 = Black happy face
3 = Heart
4 = Diamond
5 = Club
6 = Spade
7 = Black bullet
8 = White circle in Black square
9 = Black outline circle
10 = White outline circle
11 = Male
12 = Female
13 = Note
14 = Chord
15 = Sun
16 = Right button
17 = Left button
18 = Up-down arrow
19 = Double exclam
20 = Paragraph
21 = Section
22 = Thick horizontal line
23 = Up-down arrow, down underlined
24 = Up thin arrow
25 = Down thin arrow
26 = Right arrow
27 = Left arrow
28 = Left corner
29 = Circle with line through
30 = Up button
31 = Down button
"
