#!/Library/WebServer/CGI-Executables/kgi

(printf "Content-type: text/html\n\n")

(printf "<html>\n")
(printf "<head></head>\n")
(printf "<body>\n")
(printf "<h1>How to multiply numbers (cheat-sheet edition)</h1>\n")
(printf "<pre>\n")

(let ((i 0))
  (while (< i 10)
    (set i (+ i 1))
    (let ((j 0))
      (while (< j 10)
        (printf "%4d" (* i (set j (+ j 1)))))
      (printf "\n"))))

(printf "</pre>\n")

(printf "<h2>How to make a colour cube in 2 dimensions (bogus luminance version)</h2>\n")

(printf "<table cellspacing=0 cellpadding=6><tr>\n")

(let ((r 0))
  (while (< r 256)
    (let ((g 0))
      (while (< g 256)
        (let ((b 0))
          (while (< b 256)
            (let ((p (+ (* r 65536) (* g 256) b))
		  (q (if (< (+ (* r 30) (* g 59) (* b 11)) 12800) 16777215 0)))
              (printf "<td bgcolor=#%06x><font color=#%06x>%06x</font></td>\n" p q p))
            (set b (+ b 64))))
        (set g (+ g 64))))
    (printf "</tr><tr>\n")
    (set r (+ r 64))))

(printf "</tr></table>\n")

(printf "<h2>How to make a grey scale</h2>\n")

(printf "<table cellspacing=0 cellpadding=6><tr>\n")

(let ((v 0))
  (while (< v 16)
    (let ((h 0))
      (while (< h 16)
        (let ((p (+ (* h 65793) (* v 1052688)))
	      (q (if (< p 8388608) 16777215 0)))
          (printf "<td bgcolor=#%06x><font color=#%06x>%02x</font></td>\n" p q (/ p 65536)))
        (set h (+ h 1))))
    (printf "</tr><tr>\n")
    (set v (+ v 1))))

(printf "</tr></table>\n")

(printf "</body>\n")
(printf "</html>\n")
