#ifndef __vpu_Label_h
#define __vpu_Label_h


class Label
{
public:
  void *value;
  char *name;
  Label(void) { value= 0; name= 0; }
  Label(char *n) { value= 0;  name= n; }
  Label(void *a, char *n) { value= a;  name= n; }

  inline void define(void *a) { value= a; }

  inline operator void *(void) { return value; }

  void noCall(void);
  int  print(void);
  void println(void);

# define DeclareCallable(ARGS, PROTO)			\
  inline int operator()PROTO				\
    {							\
      if (!value) { noCall(); return 0; }		\
      return ((int (*)PROTO)value)ARGS;			\
    }

  DeclareCallable((),(void));
  DeclareCallable((a),(int a));
  DeclareCallable((a),(void *a));
  DeclareCallable((a),(char *a));
  DeclareCallable((a,b),(int a, int b));
  DeclareCallable((a,b),(void *a, int b));
  DeclareCallable((a,b),(char *a, int b));

  DeclareCallable((a,b,c),(int a, int b, int c));
  DeclareCallable((a,b,c,d),(int a, int b, int c, int d));
  DeclareCallable((a,b,c,d,e,f,g,h,i),(int a, int b, int c, int d, int e, int f, int g, int h, int i));
  DeclareCallable((a,b,c,d,e,f,g,h,i,j),(int a, int b, int c, int d, int e, int f, int g, int h, int i, int j));

# undef DeclareCallable
};


#endif // __vpu_Label_h
