{ import: SqueakVM }
{ import: Surface }

SqueakVM ioScreenSize		[ ^image savedWindowSize ]

DisplayScreen := [ nil ]
DisplayBits   := [ nil ]


SqueakVM ioShowDisplay_: _bits w: w h: h d: d left: left right: right top: top bottom: bottom
[
    (DisplayBits notNil
		and: [DisplayBits depth ~~ d or: [DisplayBits width  ~~ w or: [DisplayBits height ~~ h or: [_bits ~~ DisplayBits _bits]]]])
	ifTrue:
	   [DisplayBits close.
	    DisplayBits := nil].
    DisplayBits isNil
	ifTrue:
	   [DisplayBits := Pixmap withWindow: DisplayScreen width: w height: h depth: d bits_: _bits].
    DisplayBits x: left y: top w: right - left h: bottom - top
		displayOn: DisplayScreen x: left y: top.
]

SqueakVM ioGetButtonState
[
    ^0
]

SqueakVM ioMousePoint
[
    ^0
]

SqueakVM initializePlatform
[
    | w h |
    w := image savedWindowSize >> 16.
    h := image savedWindowSize bitAnd: 16rFFFF.
    ('init window ', w printString, ' ', h printString) putln.
    DisplayScreen := Window withWidth: w height: h.
]
