{ import: SqueakVM }

SqueakVM missing: what
[
    ('UNIMPLEMENTED: ', what) putln.
]

SqueakVM primitiveTable
[
    ^#(
	"Integer Primitives (0-19)"
	(  0 	 primitiveFail)
        (  1 	 primitiveAdd)
	(  2 	 primitiveSubtract)
	(  3 	 primitiveLessThan)
	(  4 	 primitiveGreaterThan)
	(  5 	 primitiveLessOrEqual)
	(  6 	 primitiveGreaterOrEqual)
	(  7 	 primitiveEqual)
	(  8 	 primitiveNotEqual)
	(  9 	 primitiveMultiply)
	( 10 	 primitiveDivide)
	( 11 	 primitiveMod)
	( 12 	 primitiveDiv)
	( 13 	 primitiveQuo)
	( 14 	 primitiveBitAnd)
	( 15 	 primitiveBitOr)
	( 16 	 primitiveBitXor)
	( 17 	 primitiveBitShift)
	( 18 	 primitiveMakePoint)
	( 19 	 primitiveFail)					"Guard primitive for simulation -- *must* fail"
	"LargeInteger Primitives (20-39)"
	"32-bit logic is aliased to Integer prims above"
	( 20  39 primitiveFail)
	"Float Primitives (40-59)"
	( 40 	 primitiveAsFloat)
	( 41 	 primitiveFloatAdd)
	( 42 	 primitiveFloatSubtract)
	( 43 	 primitiveFloatLessThan)
	( 44 	 primitiveFloatGreaterThan)
	( 45 	 primitiveFloatLessOrEqual)
	( 46 	 primitiveFloatGreaterOrEqual)
	( 47 	 primitiveFloatEqual)
	( 48 	 primitiveFloatNotEqual)
	( 49 	 primitiveFloatMultiply)
	( 50 	 primitiveFloatDivide)
	( 51 	 primitiveTruncated)
	( 52 	 primitiveFractionalPart)
	( 53 	 primitiveExponent)
	( 54 	 primitiveTimesTwoPower)
	( 55 	 primitiveSquareRoot)
	( 56 	 primitiveSine)
	( 57 	 primitiveArctan)
	( 58 	 primitiveLogN)
	( 59 	 primitiveExp)
	"Subscript and Stream Primitives (60-67)"
	( 60 	 primitiveAt)
	( 61 	 primitiveAtPut)
	( 62 	 primitiveSize)
	( 63 	 primitiveStringAt)
	( 64 	 primitiveStringAtPut)
	( 65 	 primitiveNext)
	( 66 	 primitiveNextPut)
	( 67 	 primitiveAtEnd)
	"StorageManagement Primitives (68-79)"
	( 68 	 primitiveObjectAt)
	( 69 	 primitiveObjectAtPut)
	( 70 	 primitiveNew)
	( 71 	 primitiveNewWithArg)
	( 72 	 primitiveArrayBecomeOneWay)	"Blue Book: primitiveBecome"
	( 73 	 primitiveInstVarAt)
	( 74 	 primitiveInstVarAtPut)
	( 75 	 primitiveAsOop)
	( 76 	 primitiveStoreStackp)					"Blue Book: primitiveAsObject"
	( 77 	 primitiveSomeInstance)
	( 78 	 primitiveNextInstance)
	( 79 	 primitiveNewMethod)

	"Control Primitives (80-89)"
	( 80 	 primitiveBlockCopy)
	( 81 	 primitiveValue)
	( 82 	 primitiveValueWithArgs)
	( 83 	 primitivePerform)
	( 84 	 primitivePerformWithArgs)
	( 85 	 primitiveSignal)
	( 86 	 primitiveWait)
	( 87 	 primitiveResume)
	( 88 	 primitiveSuspend)
	( 89 	 primitiveFlushCache)
	"Input/Output Primitives (90-109)"
	( 90 	 primitiveMousePoint)
	( 91 	 primitiveTestDisplayDepth)			"Blue Book: primitiveCursorLocPut"
	( 92 	 primitiveSetDisplayMode)				"Blue Book: primitiveCursorLink"
	( 93 	 primitiveInputSemaphore)
	( 94 	 primitiveGetNextEvent)				"Blue Book: primitiveSampleInterval"
	( 95 	 primitiveInputWord)
	( 96 	 primitiveCopyBits)				"primitiveCopyBits"
	( 97 	 primitiveSnapshot)
	( 98 	 primitiveStoreImageSegment)
	( 99 	 primitiveLoadImageSegment)
	(100 	 primitivePerformInSuperclass)		"Blue Book: primitiveSignalAtTick"
	(101 	 primitiveBeCursor)
	(102 	 primitiveBeDisplay)
	(103 	 primitiveScanCharacters)
	(104 	 primitiveObsoleteIndexedPrimitive)	"primitiveDrawLoop"
	(105 	 primitiveStringReplace)
	(106 	 primitiveScreenSize)
	(107 	 primitiveMouseButtons)
	(108 	 primitiveKbdNext)
	(109 	 primitiveKbdPeek)
	"System Primitives (110-119)"
	(110 	 primitiveEquivalent)
	(111 	 primitiveClass)
	(112 	 primitiveBytesLeft)
	(113 	 primitiveQuit)
	(114 	 primitiveExitToDebugger)
	(115 	 primitiveChangeClass)					"Blue Book: primitiveOopsLeft"
	(116 	 primitiveFlushCacheByMethod)
	(117 	 primitiveExternalCall)
	(118 	 primitiveDoPrimitiveWithArgs)
	(119 	 primitiveFlushCacheSelective)
	    "Squeak 2.2 and earlier use 119.  Squeak 2.3 and later use 116.  Both are supported for backward compatibility."
	"Miscellaneous Primitives (120-127)"
	(120 	 primitiveCalloutToFFI)
	(121 	 primitiveImageName)
	(122 	 primitiveNoop)					"Blue Book: primitiveImageVolume"
	(123 	 primitiveValueUninterruptably)	"@@@: Remove this when all VMs have support"
	(124 	 primitiveLowSpaceSemaphore)
	(125 	 primitiveSignalAtBytesLeft)
	"Squeak Primitives Start Here"
	"Squeak Miscellaneous Primitives (128-149)"
	(126 	 primitiveDeferDisplayUpdates)
	(127 	 primitiveShowDisplayRect)
	(128 	 primitiveArrayBecome)
	(129 	 primitiveSpecialObjectsOop)
	(130 	 primitiveFullGC)
	(131 	 primitiveIncrementalGC)
	(132 	 primitiveObjectPointsTo)
	(133 	 primitiveSetInterruptKey)
	(134 	 primitiveInterruptSemaphore)
	(135 	 primitiveMillisecondClock)
	(136 	 primitiveSignalAtMilliseconds)
	(137 	 primitiveSecondsClock)
	(138 	 primitiveSomeObject)
	(139 	 primitiveNextObject)
	(140 	 primitiveBeep)
	(141 	 primitiveClipboardText)
	(142 	 primitiveVMPath)
	(143 	 primitiveShortAt)
	(144 	 primitiveShortAtPut)
	(145 	 primitiveConstantFill)
	"NOTE: When removing the obsolete indexed primitives, the following two should go become #primitiveIntegerAt / atPut"
	(146 	 primitiveObsoleteIndexedPrimitive)	"primitiveReadJoystick"
	(147 	 primitiveObsoleteIndexedPrimitive)	"primitiveWarpBits"
	(148 	 primitiveClone)
	(149 	 primitiveGetAttribute)
	"File Primitives (150-169) - NO LONGER INDEXED"
	(150     primitiveObsoleteIndexedPrimitive)
	(151     primitiveFileClose)
	(152     primitiveObsoleteIndexedPrimitive)
	(153	 primitiveFileOpen)
	(154 160 primitiveObsoleteIndexedPrimitive)
	(161	 primitivePathNameDelimiter)
	(162 164 primitiveObsoleteIndexedPrimitive)
	(165     primitiveIntegerAt)		"hacked in here for now"
	(166     primitiveIntegerAtPut)
	(167 168 primitiveFail)
	(169     primitiveObsoleteIndexedPrimitive)
	"Sound Primitives (170-199) - NO LONGER INDEXED"
	(170 185 primitiveObsoleteIndexedPrimitive)
	"Closure primitives"
	(186 	 primitiveClosureValue)
	(187 	 primitiveClosureValueWithArgs)
	(188 	 primitiveExecuteMethod)
	"Sound Primitives (continued) - NO LONGER INDEXED"
	(189 194 primitiveObsoleteIndexedPrimitive)
	"Unwind primitives"
	(195 	 primitiveFindNextUnwindContext)
	(196 	 primitiveTerminateTo)
	(197 	 primitiveFindHandlerContext)
	(198 	 primitiveMarkUnwindMethod)
	(199 	 primitiveMarkHandlerMethod)
	"Networking Primitives (200-229) - NO LONGER INDEXED"
	(200 225 primitiveObsoleteIndexedPrimitive)
	(226 229 primitiveFail)
	"Other Primitives (230-249)"
	(230 	 primitiveRelinquishProcessor)
	(231 	 primitiveForceDisplayUpdate)
	(232 	 primitiveFormPrint)
	(233 	 primitiveSetFullScreen)
	(234 	 primitiveBitmapDecompress) "primBitmapdecompressfromByteArrayat"
	(235 	 primitiveFail)			    "primStringcomparewithcollated"
	(236 	 primitiveObsoleteIndexedPrimitive) "primSampledSoundconvert8bitSignedFromto16Bit"
	(237 	 primitiveObsoleteIndexedPrimitive) "primBitmapcompresstoByteArray"
	(238 241 primitiveObsoleteIndexedPrimitive) "serial port primitives"
	(242 	 primitiveFail)
	(243 	 primitiveObsoleteIndexedPrimitive) "primStringtranslatefromtotable"
	(244 	 primitiveObsoleteIndexedPrimitive) "primStringfindFirstInStringinSetstartingAt"
	(245 	 primitiveObsoleteIndexedPrimitive) "primStringindexOfAsciiinStringstartingAt"
	(246 	 primitiveObsoleteIndexedPrimitive) "primStringfindSubstringinstartingAtmatchTable"
	(247 	 primitiveSnapshotEmbedded)
	(248 	 primitiveInvokeObjectAsMethod)
	(249 	 primitiveFail)
	"VM Implementor Primitives (250-255)"
	(250 	 clearProfile)
	(251 	 dumpProfile)
	(252 	 startProfiling)
	(253 	 stopProfiling)
	(254 	 primitiveVMParameter)
	(255 	 primitiveInstVarsPutFromStack) "Never used except in Disney tests.  Remove after 2.3 release."
	"Quick Push Const Methods"
	(256 	 primitivePushSelf)
	(257 	 primitivePushTrue)
	(258 	 primitivePushFalse)
	(259 	 primitivePushNil)
	(260 	 primitivePushMinusOne)
	(261 	 primitivePushZero)
	(262 	 primitivePushOne)
	(263 	 primitivePushTwo)
	"Quick Push Const Methods"
	(264 519 primitiveLoadInstVar)
	"MIDI Primitives (520-539) - NO LONGER INDEXED"
	(520 529 primitiveObsoleteIndexedPrimitive)
	(530 539 primitiveFail)  "reserved for extended MIDI primitives"
	"Experimental Asynchrous File Primitives - NO LONGER INDEXED"
	(540 545 primitiveObsoleteIndexedPrimitive)
	(546 547 primitiveFail)
	"Pen Tablet Primitives - NO LONGER INDEXED"
	(548 	 primitiveObsoleteIndexedPrimitive)
	(549 	 primitiveObsoleteIndexedPrimitive)
	"Sound Codec Primitives - NO LONGER INDEXED"
	(550 553 primitiveObsoleteIndexedPrimitive)
	(554 569 primitiveFail)
	"External primitive support primitives"
	(570 	 primitiveFlushExternalPrimitives)
	(571 	 primitiveUnloadModule)
	(572 	 primitiveListBuiltinModule)
	(573 	 primitiveListExternalModule)
	(574 	 primitiveFail) "reserved for addl. external support prims"
	"Unassigned Primitives"
	(575 700 primitiveFail)
    )
]


SqueakVM primitiveFail
[
    successFlag := false.
    ('fail primitive ', primitiveIndex printString) putln.
]

SqueakVM primitiveAdd
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    result := rcvr + arg.
    result - arg == rcvr
	ifTrue:  [self pop2thenPush: result]
	ifFalse: [successFlag := false].
]

SqueakVM primitiveSubtract
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    result := rcvr - arg.
    result + arg == rcvr
	ifTrue:  [self pop2thenPush: result]
	ifFalse: [successFlag := false].
]

SqueakVM primitiveLessThan
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr < arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveGreaterThan
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr > arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveLessOrEqual
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr <= arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveGreaterOrEqual
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr >= arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveEqual
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg :=  self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr == arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveNotEqual
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg :=  self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr ~~ arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveMultiply
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    result := rcvr * arg.
    (arg == 0 or: [result // arg == rcvr])
	ifTrue:  [self pop2thenPush: result]
	ifFalse: [successFlag := false].
]

SqueakVM primitiveDivide
[
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger and: [arg ~~ 0]]) ifFalse: [^successFlag := false].
    result := rcvr // arg.
    result * arg == rcvr
	ifTrue:  [self pop2thenPush: result]
	ifFalse: [successFlag := false].
]

SqueakVM primitiveMod
[
    | result rcvr arg |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isSmallInteger and: [arg isSmallInteger and: [arg ~~ 0]]) ifFalse: [^successFlag := false].
    result := rcvr \\ arg.
    "ensure that the result has the same sign as the arg"
    arg < 0
	ifTrue:  [result > 0 ifTrue: [result := result + arg]]
	ifFalse: [result < 0 ifTrue: [result := result + arg]].
    self pop2thenPush: result
]

SqueakVM primitiveDiv
[
    "Rounds negative results towards negative infinity, rather than zero."
    | rcvr arg result |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    {
      if ((int)v_rcvr & (int)v_arg & 1)
        {
          int rcvr= (int)v_rcvr >> 1;
          int arg=  (int)v_arg  >> 1;
	  int result= 0;
	  if (rcvr > 0)
	    {
	      if (arg > 0)
		  result= rcvr / arg;
	      else
		{
		  arg= 0 - arg;
		  result= 0 - ((rcvr + (arg - 1)) / arg);
		}
	    }
	  else
	    {
	      rcvr= 0 - rcvr;
	      if (arg > 0)
		  result= 0 - ((rcvr + (arg - 1)) / arg);
	      else
		{
		  arg= 0 - arg;
		  result= rcvr / arg;
		}
	    }
	  if ((result ^ (result << 1)) >= 0)
	    v_result= (oop)(result << 1 | 1);
        }
    }.
    result isNil ifTrue: [^successFlag := false].
    self pop2thenPush: result.
]

SqueakVM primitiveQuo				[ successFlag := false.  self error: 'primitiveQuo' ]

SqueakVM primitiveBitAnd
[
    | integerReceiver integerArgument |
    integerArgument := self _popPos32BitInteger.
    integerReceiver := self _popPos32BitInteger.
    successFlag ifFalse: [^self unPop: 2].
    { v_integerReceiver= (oop)((unsigned int)v_integerReceiver & (unsigned int)v_integerArgument); }.
    self push: (self positive32BitIntegerFor_: integerReceiver)
]

SqueakVM primitiveBitOr
[
    | integerReceiver integerArgument |
    integerArgument := self _popPos32BitInteger.
    integerReceiver := self _popPos32BitInteger.
    successFlag ifFalse: [^self unPop: 2].
    { v_integerReceiver= (oop)((unsigned int)v_integerReceiver | (unsigned int)v_integerArgument); }.
    self push: (self positive32BitIntegerFor_: integerReceiver)
]

SqueakVM primitiveBitXor
[
    | integerReceiver integerArgument |
    integerArgument := self _popPos32BitInteger.
    integerReceiver := self _popPos32BitInteger.
    successFlag ifFalse: [^self unPop: 2].
    { v_integerReceiver= (oop)((unsigned int)v_integerReceiver ^ (unsigned int)v_integerArgument); }.
    self push: (self positive32BitIntegerFor_: integerReceiver)
]

SqueakVM primitiveBitShift
[
    | integerReceiver integerArgument integerResult |
    integerArgument := self _popInteger.
    integerReceiver := self _popPos32BitInteger.
    successFlag ifFalse: [^self unPop: 2].
    {
      if ((int)v_integerArgument < 0)
        v_integerResult= (oop)((unsigned int)v_integerReceiver >> -(int)v_integerArgument);
      else
        {
          if ((int)v_integerArgument > 31)
            self->v_successFlag= 0;
          else
            {
              v_integerResult= (oop)((unsigned int)v_integerReceiver << (int)v_integerArgument);
	      if (((unsigned int)v_integerResult >> (int)v_integerArgument) != (unsigned int)v_integerReceiver)
                self->v_successFlag= 0;
            }
        }
    }.
    successFlag ifFalse: [^self unPop: 2].
    self push: (self positive32BitIntegerFor_: integerResult)
]

SqueakVM primitiveMakePoint
[
    | rcv arg pt |
    arg := self stackTop.
    rcv := self stackValue: 1.
    (rcv isSmallInteger and: [arg isSmallInteger]) ifFalse: [^successFlag := false].
    self pop2thenPush: (self makePointwithxValue: rcv yValue: arg).
]

SqueakVM primitiveAsFloat
[
    | arg float _float |
    (arg := self stackTop) isSmallInteger ifFalse: [^successFlag := false].
    float := self newFloat.
    _float := float _elements.
    {
      double d= (double)((int)v_arg >> 1);
      memcpy((void *)v__float, &d, sizeof(d));
    }.
    self popThenPush: float
]

SqueakVM primitiveFloatAdd
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: rcvr + arg.
]

SqueakVM primitiveFloatSubtract
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: rcvr - arg
]

SqueakVM primitiveFloatLessThan
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: (rcvr < arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveFloatGreaterThan
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: (rcvr > arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveFloatLessOrEqual
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: (rcvr <= arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveFloatGreaterOrEqual
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: (rcvr >= arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveFloatEqual
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: (rcvr = arg ifTrue: [trueObj] ifFalse: [falseObj])
]

SqueakVM primitiveFloatNotEqual
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: (rcvr ~= arg ifTrue: [trueObj] ifFalse: [falseObj])
]


SqueakVM primitiveFloatMultiply
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    successFlag ifFalse: [^self unPop: 2].
    self push: rcvr * arg
]

SqueakVM primitiveFloatDivide
[
    | rcvr arg |
    rcvr := self popFloatOrInt.
    arg  := self popFloatOrInt.
    arg = 0.0 ifTrue: [successFlag := false].
    successFlag ifFalse: [^self unPop: 2].
    self push: rcvr / arg
]

SqueakVM primitiveTruncated
[
    | rcvr |
    rcvr := self stackTop.
    (self isFloat: rcvr) ifFalse: [^successFlag := false].
    self popThenPush: rcvr truncated
]

SqueakVM primitiveFractionalPart		[ successFlag := false.  self error: 'primitiveFractionalPart' ]
SqueakVM primitiveExponent			[ successFlag := false.  self error: 'primitiveExponent' ]
SqueakVM primitiveTimesTwoPower			[ successFlag := false.  self error: 'primitiveTimesTwoPower' ]
SqueakVM primitiveSquareRoot			[ successFlag := false.  self error: 'primitiveSquareRoot' ]
SqueakVM primitiveSine				[ successFlag := false.  self error: 'primitiveSine' ]
SqueakVM primitiveArctan			[ successFlag := false.  self error: 'primitiveArctan' ]
SqueakVM primitiveLogN				[ successFlag := false.  self error: 'primitiveLogN' ]
SqueakVM primitiveExp				[ successFlag := false.  self error: 'primitiveExp' ]

SqueakVM primitiveAt
[
    | rcvr arg elt |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isSmallInteger not and: [rcvr hasIndexableFields and: [arg isSmallInteger and: [arg > 0 and: [arg <= rcvr indexableSize]]]])
	ifFalse: [^successFlag := false].
    elt := rcvr isWords
	ifTrue:  [self positive32BitIntegerFor_: (rcvr _indexedWordAt: arg)]
	ifFalse: [rcvr indexedAt: arg].
    self pop2thenPush: elt
]

SqueakVM primitiveAtPut
[
    | rcvr arg obj |
    rcvr := self stackValue: 2.
    arg  := self stackValue: 1.
    obj  := self stackTop.
    (rcvr isSmallInteger not and: [rcvr hasIndexableFields and: [arg isSmallInteger and: [arg > 0 and: [arg <= rcvr indexableSize]]]])
	ifTrue:
	   [(rcvr canStore: obj) ifTrue: [^self pop3thenPush: (rcvr indexedAt: arg put: obj)].
	    (rcvr isWords and: [(self fetchClassOf: obj) == image classLargePositiveInteger and: [obj indexableSize == 4]])
		ifTrue:
		   [rcvr _indexedWordAt: arg put_: obj _largeIntegerValue.
		    ^self pop3thenPush: obj]].
    (rcvr printString, ' cannot store ', obj printString, ' at ', arg printString) putln.
    Smalltalk quit.
    successFlag := false
]

SqueakVM primitiveSize
[
    | rcvr |
    rcvr := self stackTop.
    (rcvr isSmallInteger not and: [rcvr hasIndexableFields]) ifFalse: [^successFlag := false].
    self popThenPush: rcvr indexableSize.
]

SqueakVM primitiveStringAt
[
    | rcvr arg |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    (rcvr isBytes and: [arg isSmallInteger and: [arg > 0 and: [arg <= rcvr indexableSize]]])
	ifFalse: [^successFlag := false].
    self pop2thenPush: (image characterTable indexedAt: 1 + (rcvr indexedAt: arg))
]

SqueakVM primitiveStringAtPut
[
    | rcvr arg obj |
    rcvr := self stackValue: 2.
    arg  := self stackValue: 1.
    obj  := self stackTop.
    (rcvr isBytes and: [arg isSmallInteger and: [arg > 0 and: [arg <= rcvr indexableSize
		and: [(self fetchClassOf: obj) == image classCharacter]]]])
	ifFalse: [^successFlag := false].
    rcvr indexedAt: arg put: obj atCharacterValueIndex.
    self pop3thenPush: obj.
]

SqueakVM primitiveNext				[ successFlag := false ]
SqueakVM primitiveNextPut			[ successFlag := false ]
SqueakVM primitiveAtEnd				[ successFlag := false ]

SqueakVM primitiveObjectAt
[
    | rcvr index |
    rcvr  := self stackValue: 1.
    index := self stackTop.
    (rcvr isSqueakMethod and: [index isSmallInteger and: [index > 0 and: [index <= (rcvr literalsSize + 1)]]])
	ifFalse: [^successFlag := false].
    self pop2thenPush: (index == 1 ifTrue: [rcvr methodHeader] ifFalse: [rcvr literalAt: index - 1]).
]

SqueakVM primitiveObjectAtPut			[ successFlag := false.  self error: 'primitiveObjectAtPut' ]

SqueakVM primitiveNew
[
    self popThenPush: (self instantiateClass: self stackTop indexableSize: 0)
]

SqueakVM primitiveNewWithArg
[
    | size class |
    size := self stackTop.
    class := self stackValue: 1.
    "'###\t' put. class print.  ' new: ' put.  size println."
    (size isSmallInteger and: [size >= 0])
	ifTrue:  [self pop: 2 thenPush: (self instantiateClass: class indexableSize: size)]
	ifFalse: [successFlag := false]
]

SqueakVM primitiveArrayBecomeOneWay		[ successFlag := false.  self error: 'primitiveArrayBecomeOneWay' ]

SqueakVM primitiveInstVarAt
[
    | index rcvr |
    rcvr  := self stackValue: 1.
    index := self stackTop.
    (index isSmallInteger and: [index > 0 and: [index <= rcvr fixedSize]]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr instVarAt: index).
]

SqueakVM primitiveInstVarAtPut
[
    | index rcvr |
    rcvr  := self stackValue: 2.
    index := self stackValue: 1.
    (index isSmallInteger and: [index > 0 and: [index <= rcvr fixedSize]]) ifFalse: [^successFlag := false].
    self pop2thenPush: (rcvr instVarAt: index put: self stackTop).
]

SqueakVM primitiveAsOop
[
    | rcvr |
    rcvr := self stackTop.
    rcvr isSmallInteger ifTrue: [^successFlag := false].
    self popThenPush: rcvr hashBits.
]

SqueakVM primitiveStoreStackp			[ successFlag := false.  self error: 'primitiveStoreStackp' ]
SqueakVM primitiveSomeInstance			[ successFlag := false.  self error: 'primitiveSomeInstance' ]
SqueakVM primitiveNextInstance			[ successFlag := false.  self error: 'primitiveNextInstance' ]
SqueakVM primitiveNewMethod			[ successFlag := false.  self error: 'primitiveNewMethod' ]

SqueakVM primitiveBlockCopy
[
    | context methodContext newContext initialIP |
    context := self stackValue: 1.
    methodContext := context atMethodIndex isSmallInteger
	ifTrue:  [context atHomeIndex]
	ifFalse: [context].
    newContext := self instantiateContext: image classBlockContext indexableSize: context indexableSize.
    initialIP := instructionPointer + 2.
    newContext
	atSenderIndexPut:		nilObj;
	atInstructionPointerIndexPut:	initialIP;
	atStackPointerIndexPut:		0;
	atBlockArgumentCountIndexPut:	(self stackTop);
	atInitialIPIndexPut:		initialIP;
	atHomeIndexPut:			methodContext.
    self pop: 2 thenPush: newContext.
]

SqueakVM primitiveValue
[
    | blockContext blockArgumentCount initialIP |
    blockContext := self stackValue: argumentCount.
    blockArgumentCount := blockContext atBlockArgumentCountIndex.
    (argumentCount == blockArgumentCount and: [blockContext atSenderIndex == nilObj]) ifFalse: [^successFlag := false].
    self transfer:  argumentCount
	 fromIndex: stackPointer - argumentCount + 1
	 ofObject:  activeContext
	 toIndex:   1
	 ofObject:  blockContext.
    self pop: argumentCount + 1.
    initialIP := blockContext atInitialIPIndex.
    blockContext
	atSenderIndexPut: activeContext;
	atStackPointerIndexPut: argumentCount;
	atInstructionPointerIndexPut: initialIP.
    self newActiveContext: blockContext
]

SqueakVM primitiveValueWithArgs			[ successFlag := false.  self error: 'primitiveValueWithArgs' ]

SqueakVM primitivePerform
[
    | performSelector newReceiver selectorIndex lookupClass performMethod |
    performSelector := messageSelector.
    performMethod := newMethod.
    messageSelector := self stackValue: argumentCount - 1.
    newReceiver := self stackValue: argumentCount.
    "Slide arguments down over selector"
    argumentCount := argumentCount - 1.
    selectorIndex := stackPointer - argumentCount.
    self transfer:  argumentCount
	 fromIndex: selectorIndex + 1
	 ofObject:  activeContext
	 toIndex:   selectorIndex
	 ofObject:  activeContext.
    self pop: 1.
    lookupClass := self fetchClassOf: newReceiver.
    self findNewMethodInClass: lookupClass.
    (newMethod numArgs == argumentCount)
	ifTrue:
	   [self executeNewMethod.
	    successFlag := true]  "Recursive xeq affects successFlag"
	ifFalse:
	   ["Slide the args back up (sigh) and re-insert the selector."
	    argumentCount downTo: 1 do: [:i |
		activeContext indexedAt: selectorIndex + i put: (activeContext indexedAt: selectorIndex - 1 + i)].
	    self unPop: 1.
	    activeContext indexedAt: selectorIndex put: messageSelector.
	    argumentCount := argumentCount + 1.
	    newMethod := performMethod.
	    messageSelector := performSelector.
	    successFlag := false]
]

SqueakVM primitivePerformWithArgs		[ successFlag := false.  self error: 'primitivePerformWithArgs' ]

SqueakVM primitiveSignal
[
    | sema |
    sema := self stackTop.
    (self fetchClassOf: sema) == image classSemaphore ifFalse: [^successFlag := false].
    self synchronousSignal: sema
]

SqueakVM primitiveWait
[
    | sema excessSignals |
    sema := self stackTop.
    (self fetchClassOf: sema) == image classSemaphore ifFalse: [^successFlag := false].
    (excessSignals := sema atExcessSignalsIndex) > 0
	ifTrue: [sema atExcessSignalsIndexPut: excessSignals - 1]
	ifFalse:
	    [self addLastLink: self schedulerPointer atActiveProcessIndex toList: sema.
	     self transferTo: self wakeHighestPriority]
]

SqueakVM primitiveResume
[
    self resume: self stackTop
]

SqueakVM primitiveSuspend
[
    | activeProc |
    activeProc := self schedulerPointer atActiveProcessIndex.
    self stackTop == activeProc ifFalse: [^successFlag := false].
    self popThenPush: nilObj.
    self transferTo: self wakeHighestPriority.
]

SqueakVM primitiveFlushCache			[ successFlag := false.  self error: 'primitiveFlushCache' ]

SqueakVM primitiveMousePoint
[
    "Answer a Point indicating current position of the mouse. Note
    that mouse coordinates may be negative if the mouse moves above or
    to the left of the top-left corner of the Smalltalk window."
    | pointWord x y |
    self pop: 1.
    pointWord := self ioMousePoint.
    x := self signExtend16: ((pointWord >> 16) bitAnd: 16rFFFF).
    y := self signExtend16: (pointWord bitAnd: 16rFFFF).
    self push: (self makePointwithxValue: x yValue: y).
]

SqueakVM primitiveTestDisplayDepth		[ successFlag := false.  self error: 'primitiveTestDisplayDepth' ]
SqueakVM primitiveSetDisplayMode		[ successFlag := false.  self error: 'primitiveSetDisplayMode' ]
SqueakVM primitiveInputSemaphore		[ successFlag := false.  self error: 'primitiveInputSemaphore' ]
SqueakVM primitiveGetNextEvent			[ successFlag := false.  self error: 'primitiveGetNextEvent' ]
SqueakVM primitiveInputWord			[ successFlag := false.  self error: 'primitiveInputWord' ]
SqueakVM primitiveSnapshot			[ successFlag := false.  self error: 'primitiveSnapshot' ]
SqueakVM primitiveStoreImageSegment		[ successFlag := false.  self error: 'primitiveStoreImageSegment' ]
SqueakVM primitiveLoadImageSegment		[ successFlag := false.  self error: 'primitiveLoadImageSegment' ]
SqueakVM primitivePerformInSuperclass		[ successFlag := false.  self error: 'primitivePerformInSuperclass' ]

SqueakVM primitiveBeCursor
[
    self missing: 'primitiveBeCursor'.
    self pop: argumentCount.
"
    | cursorObj maskBitsIndex maskObj bitsObj extentX extentY depth offsetObj offsetX offsetY cursorBitsIndex ourCursor |
    argumentCount = 0 ifTrue: [
        cursorObj := self stackTop.
        maskBitsIndex := nil].
    argumentCount = 1 ifTrue: [
        cursorObj := self stackValue: 1.
        maskObj := self stackTop].
    self success: (argumentCount < 2).

    self success: ((self isPointers: cursorObj) and: [(self lengthOf: cursorObj) >= 5]).
    successFlag ifTrue: [
        bitsObj := self fetchPointer: 0 ofObject: cursorObj.
        extentX := self fetchInteger: 1 ofObject: cursorObj.
        extentY := self fetchInteger: 2 ofObject: cursorObj.
        depth := self fetchInteger: 3 ofObject: cursorObj.
        offsetObj := self fetchPointer: 4 ofObject: cursorObj].
        self success: ((self isPointers: offsetObj) and: [(self lengthOf: offsetObj) >= 2]).

    successFlag ifTrue: [
        offsetX := self fetchInteger: 0 ofObject: offsetObj.
        offsetY := self fetchInteger: 1 ofObject: offsetObj.
        self success: ((extentX = 16) and: [extentY = 16 and: [depth = 1]]).
        self success: ((offsetX >= -16) and: [offsetX <= 0]).
        self success: ((offsetY >= -16) and: [offsetY <= 0]).
        self success: ((self isWords: bitsObj) and: [(self lengthOf: bitsObj) = 16]).
        cursorBitsIndex := bitsObj + BaseHeaderSize.
        self cCode: '' inSmalltalk:
            [ourCursor := Cursor
                extent: extentX @ extentY
                fromArray: ((1 to: 16) collect: [:i |
                    ((self fetchWord: i-1 ofObject: bitsObj) >> 16) bitAnd: 16rFFFF])
                offset: offsetX  @ offsetY]].

    argumentCount = 1 ifTrue: [
        self success: ((self isPointers: maskObj) and: [(self lengthOf: maskObj) >= 5]).
        successFlag ifTrue: [
            bitsObj := self fetchPointer: 0 ofObject: maskObj.
            extentX := self fetchInteger: 1 ofObject: maskObj.
            extentY := self fetchInteger: 2 ofObject: maskObj.
            depth := self fetchInteger: 3 ofObject: maskObj].

        successFlag ifTrue: [
            self success: ((extentX = 16) and: [extentY = 16 and: [depth = 1]]).
            self success: ((self isWords: bitsObj) and: [(self lengthOf: bitsObj) = 16]).
            maskBitsIndex := bitsObj + BaseHeaderSize]].

    successFlag ifTrue: [
        argumentCount = 0
            ifTrue: [self cCode: 'ioSetCursor(cursorBitsIndex, offsetX, offsetY)'
                        inSmalltalk: [ourCursor show]]
            ifFalse: [self cCode: 'ioSetCursorWithMask(cursorBitsIndex, maskBitsIndex, offsetX, offsetY)'
                        inSmalltalk: [ourCursor show]].
        self pop: argumentCount].
"
]

SqueakVM primitiveBeDisplay
[
    | rcvr |
    rcvr := self stackTop.
    (rcvr isSmallInteger not and: [rcvr isPointers and: [rcvr fixedSize >= 4]])
	ifTrue:  [image theDisplay: rcvr]
	ifFalse: [successFlag := false]
]

SqueakVM primitiveScanCharacters		[ successFlag := false ]
SqueakVM primitiveStringReplace			[ successFlag := false ]

SqueakVM primitiveScreenSize
[
    | pointWord |
    pointWord := self ioScreenSize.
    self popThenPush: (self makePointwithxValue: ((pointWord >> 16) bitAnd: 16rFFFF)
			    yValue: (pointWord bitAnd: 16rFFFF))
]

SqueakVM primitiveMouseButtons
[
    "Answer the mouse button state.  The low three bits encode the
    state of the <red><yellow><blue> mouse buttons.  The next four
    bits encode the Smalltalk modifier bits
    <cmd><option><ctrl><shift>."
    self popThenPush: self ioGetButtonState
]

SqueakVM primitiveKbdNext			[ successFlag := false.  self error: 'primitiveKbdNext' ]
SqueakVM primitiveKbdPeek			[ successFlag := false.  self error: 'primitiveKbdPeek' ]

SqueakVM primitiveEquivalent
[
    | rcvr arg |
    rcvr := self stackValue: 1.
    arg  := self stackTop.
    self pop2thenPush: (rcvr == arg ifTrue: [trueObj] ifFalse: [falseObj]).
]

SqueakVM primitiveClass				[ self popThenPush: (self fetchClassOf: self stackTop) ]

SqueakVM primitiveBytesLeft			[ successFlag := false.  self error: 'primitiveBytesLeft' ]
SqueakVM primitiveQuit				[ successFlag := false.  self error: 'primitiveQuit' ]
SqueakVM primitiveExitToDebugger		[ successFlag := false.  self error: 'primitiveExitToDebugger' ]
SqueakVM primitiveChangeClass			[ successFlag := false.  self error: 'primitiveChangeClass' ]
SqueakVM primitiveFlushCacheByMethod		[ successFlag := false.  self error: 'primitiveFlushCacheByMethod' ]

SqueakVM primitiveExternalCall			[ successFlag := false.  self error: 'primitiveExternalCall' ]


SqueakVM primitiveDoPrimitiveWithArgs		[ successFlag := false.  self error: 'primitiveDoPrimitiveWithArgs' ]
SqueakVM primitiveFlushCacheSelective		[ successFlag := false.  self error: 'primitiveFlushCacheSelective' ]
SqueakVM primitiveCalloutToFFI			[ successFlag := false.  self error: 'primitiveCalloutToFFI' ]

SqueakVM primitiveImageName
[
    "When called with a single string argument, record the string as
    the current image file name.  When called with zero arguments,
    answer a string containing the current image file name."
    argumentCount == 1
	ifTrue:
	   [self error: 'primitiveImageName: unimplemented']
	ifFalse:
	   [| imageName string size |
	    imageName := image name.
	    size := imageName size.
	    string := self instantiateClass: image classString indexableSize: size.
	    1 to: size do: [:i | string indexedAt: i put: (imageName byteAt: i)].
	    self popThenPush: string]
]

SqueakVM primitiveNoop				[ self pop: argumentCount ]
SqueakVM primitiveValueUninterruptably		[ successFlag := false.  self error: 'primitiveValueUninterruptably' ]
SqueakVM primitiveLowSpaceSemaphore		[ self pop ]
SqueakVM primitiveSignalAtBytesLeft		[ self pop ]
SqueakVM primitiveDeferDisplayUpdates		[ successFlag := false.  self error: 'primitiveDeferDisplayUpdates' ]
SqueakVM primitiveShowDisplayRect		[ successFlag := false.  self error: 'primitiveShowDisplayRect' ]
SqueakVM primitiveArrayBecome			[ successFlag := false.  self error: 'primitiveArrayBecome' ]
SqueakVM primitiveSpecialObjectsOop		[ successFlag := false.  self error: 'primitiveSpecialObjectsOop' ]
SqueakVM primitiveFullGC			[ successFlag := false.  self error: 'primitiveFullGC' ]
SqueakVM primitiveIncrementalGC			[ self popThenPush: 4934994 ]
SqueakVM primitiveObjectPointsTo		[ successFlag := false.  self error: 'primitiveObjectPointsTo' ]
SqueakVM primitiveSetInterruptKey		[ successFlag := false.  self error: 'primitiveSetInterruptKey' ]
SqueakVM primitiveInterruptSemaphore		[ self pop ]
SqueakVM primitiveMillisecondClock		[ self popThenPush: (Time millisecondClockValue bitAnd: 16r1FFFFFFF) ]
SqueakVM primitiveSignalAtMilliseconds		[ successFlag := false.  self error: 'primitiveSignalAtMilliseconds' ]
SqueakVM primitiveSecondsClock			[ successFlag := false.  self error: 'primitiveSecondsClock' ]
SqueakVM primitiveSomeObject			[ successFlag := false.  self error: 'primitiveSomeObject' ]
SqueakVM primitiveNextObject			[ successFlag := false.  self error: 'primitiveNextObject' ]
SqueakVM primitiveBeep				[ successFlag := false.  self error: 'primitiveBeep' ]
SqueakVM primitiveClipboardText			[ successFlag := false.  self error: 'primitiveClipboardText' ]

SqueakVM primitiveVMPath
[
    | vmPath string size |
    vmPath := image vmPathName.
    size := vmPath lastIndexOf: $/.
    size == 0 ifTrue: [size := vmPath size].
    string := self instantiateClass: image classString indexableSize: size.
    1 to: size do: [:i | string indexedAt: i put: (vmPath byteAt: i)].
    self popThenPush: string
]

SqueakVM primitiveShortAt			[ successFlag := false.  self error: 'primitiveShortAt' ]
SqueakVM primitiveShortAtPut			[ successFlag := false.  self error: 'primitiveShortAtPut' ]
SqueakVM primitiveConstantFill			[ successFlag := false.  self error: 'primitiveConstantFill' ]

SqueakVM primitiveClone
[
    | proto copy |
    proto := self stackTop.
    copy  := self instantiateClass: proto fetchClass indexableSize: proto indexableSize.
    1 to: proto fixedSize do: [:i | copy instVarAt: i put: (proto instVarAt: i)].
    1 to: proto indexableSize do: [:i | copy indexedAt: i put: (proto indexedAt: i)].
    self popThenPush: copy
]

SqueakVM primitiveGetAttribute			[ successFlag := false.  self error: 'primitiveGetAttribute' ]

SqueakVM primitiveFileClose			[ 'file not closed' putln ]

SqueakVM primitiveFileOpen
[
    | namePointer writeFlag fileName file |
    namePointer := self stackValue: 1.
    writeFlag := self stackTop.
    (namePointer isSmallInteger not and: [namePointer isBytes]) ifFalse: [^successFlag := false].
    fileName := namePointer stringContents.
    file := writeFlag ifTrue: [File openForWriting: fileName] ifFalse: [File openForReading: fileName].
    file isNil ifTrue: [^successFlag := false].
    filesOpen addLast: file.
    self pop3thenPush: filesOpen size
]

SqueakVM primitivePathNameDelimiter		[ self popThenPush: (image characterTable indexedAt: 1 + $/ asciiValue) ]
SqueakVM primitiveIntegerAt			[ successFlag := false.  self error: 'primitiveIntegerAt' ]
SqueakVM primitiveIntegerAtPut			[ successFlag := false.  self error: 'primitiveIntegerAtPut' ]
SqueakVM primitiveClosureValue			[ successFlag := false.  self error: 'primitiveClosureValue' ]
SqueakVM primitiveClosureValueWithArgs		[ successFlag := false.  self error: 'primitiveClosureValueWithArgs' ]
SqueakVM primitiveExecuteMethod			[ successFlag := false.  self error: 'primitiveExecuteMethod' ]
SqueakVM primitiveFindNextUnwindContext		[ successFlag := false.  self error: 'primitiveFindNextUnwindContext' ]
SqueakVM primitiveTerminateTo			[ successFlag := false.  self error: 'primitiveTerminateTo' ]
SqueakVM primitiveFindHandlerContext		[ successFlag := false.  self error: 'primitiveFindHandlerContext' ]
SqueakVM primitiveMarkUnwindMethod		[ successFlag := false.  self error: 'primitiveMarkUnwindMethod' ]
SqueakVM primitiveMarkHandlerMethod		[ successFlag := false.  self error: 'primitiveMarkHandlerMethod' ]
SqueakVM primitiveRelinquishProcessor		[ successFlag := false.  self error: 'primitiveRelinquishProcessor' ]
SqueakVM primitiveForceDisplayUpdate		[ successFlag := false.  self error: 'primitiveForceDisplayUpdate' ]
SqueakVM primitiveFormPrint			[ successFlag := false.  self error: 'primitiveFormPrint' ]
SqueakVM primitiveSetFullScreen			[ successFlag := false.  self error: 'primitiveSetFullScreen' ]
SqueakVM primitiveBitmapDecompress		[ successFlag := false ]
SqueakVM primitiveSnapshotEmbedded		[ successFlag := false.  self error: 'primitiveSnapshotEmbedded' ]
SqueakVM primitiveInvokeObjectAsMethod		[ successFlag := false.  self error: 'primitiveInvokeObjectAsMethod' ]
SqueakVM clearProfile				[ successFlag := false.  self error: 'clearProfile' ]
SqueakVM dumpProfile				[ successFlag := false.  self error: 'dumpProfile' ]
SqueakVM startProfiling				[ successFlag := false.  self error: 'startProfiling' ]
SqueakVM stopProfiling				[ successFlag := false.  self error: 'stopProfiling' ]
SqueakVM primitiveVMParameter			[ successFlag := false.  self error: 'primitiveVMParameter' ]
SqueakVM primitiveInstVarsPutFromStack		[ successFlag := false.  self error: 'primitiveInstVarsPutFromStack' ]

SqueakVM primitivePushSelf			["self popThenPush: self stackTop"]
SqueakVM primitivePushTrue			[ self popThenPush: trueObj ]
SqueakVM primitivePushFalse			[ self popThenPush: falseObj ]
SqueakVM primitivePushNil			[ self popThenPush: nilObj ]
SqueakVM primitivePushMinusOne			[ self popThenPush: -1 ]
SqueakVM primitivePushZero			[ self popThenPush:  0 ]
SqueakVM primitivePushOne			[ self popThenPush:  1 ]
SqueakVM primitivePushTwo			[ self popThenPush:  2 ]
SqueakVM primitiveLoadInstVar			[ self popThenPush: (self stackTop instVarAt: primitiveIndex - 263) ]

SqueakVM primitiveFlushExternalPrimitives	[ successFlag := false.  self error: 'primitiveFlushExternalPrimitives' ]
SqueakVM primitiveUnloadModule			[ successFlag := false.  self error: 'primitiveUnloadModule' ]
SqueakVM primitiveListBuiltinModule		[ successFlag := false.  self error: 'primitiveListBuiltinModule' ]
SqueakVM primitiveListExternalModule		[ successFlag := false.  self error: 'primitiveListExternalModule' ]

SqueakVM primitiveObsoleteIndexedPrimitive
[
    ^self error: 'obsolete primitive ', primitiveIndex printString, ' -> ', messageSelector stringContents
]

{ import: SqueakVM-proxy }
{ import: SqueakVM-BitBlt }

SqueakVM initializePrimitives
[
    filesOpen := OrderedCollection new.
    BitBlt initialiseModule; setInterpreter: self getProxy.
]

SqueakVM error: message
[
    'ERROR: ' put.
    message putln.
]
