" idc Surface-test.st -L/usr/X11R6/lib -lX11 "

{ input: Surface }

W := [ 200 ]
H := [ 200 ]
D := [  16 ]

[
    | win r g b cycle freeze done evt |
    win := Window withWidth: W * 3 + 20 height: H + 20.
    r := Pixmap withWindow: win width: W height: H depth: D.
    g := Pixmap withWindow: win width: W height: H depth: D.
    b := Pixmap withWindow: win width: W height: H depth: D.

    (D == 32 or: [D == 24])
	ifTrue:
	   [1 to: W * H do: [:i |
	       r intAt: i put: 0xFF0000.
	       g intAt: i put: 0x00FF00.
	       b intAt: i put: 0x0000FF]]
	ifFalse:
	   [(D == 16)
		ifTrue:
		   [1 to: W * H do: [:i |
		       r shortAt: i put: 31 << 10.
		       g shortAt: i put: 31 <<  5.
		       b shortAt: i put: 31      ]]
		ifFalse:
		   [Smalltalk error: 'cannot initialise pixmaps at requested depth']].
    cycle := 0.
    freeze := false.
    done := false.
    [done]
	whileFalse:
	   [evt := win nextEvent: false.
	    evt isNil
		ifFalse:
		    [(evt isKeyRelease and: [evt key == 27]) ifTrue: [done := true].
		     evt isButtonPress   ifTrue: [freeze := true].
		     evt isButtonRelease ifTrue: [freeze := false]].
	    freeze
		ifFalse:
		   [| j |
		    j := cycle \\ 3.
		    j == 0
			ifTrue:
			   [r displayOn: win x: 10 + (W * 0) y: 10.
			    g displayOn: win x: 10 + (W * 1) y: 10.
			    b displayOn: win x: 10 + (W * 2) y: 10].
		    j == 1
			ifTrue:
			   [g displayOn: win x: 10 + (W * 0) y: 10.
			    b displayOn: win x: 10 + (W * 1) y: 10.
			    r displayOn: win x: 10 + (W * 2) y: 10].
		    j == 2
			ifTrue:
			   [b displayOn: win x: 10 + (W * 0) y: 10.
			    r displayOn: win x: 10 + (W * 1) y: 10.
			    g displayOn: win x: 10 + (W * 2) y: 10]].
	    cycle := cycle + 1].

  win close.
]
