{ import: Object }

Scanner : Object ( characterTable stream nextChar )

Scanner on: aStream
[
    self := self new initialize.
    stream := aStream.
    self nextChar.
]

Scanner initialize	[ characterTable := Array new: 256 withAll: #xIllegal ]

Scanner atEnd		[ ^nextChar isNil ]
Scanner nextChar	[ ^nextChar := stream next ]

Scanner nextToken
[
    | token |
    [nextChar notNil and: [(token := self perform: (characterTable at: nextChar)) isNil]] whileTrue.
    ^token
]

Scanner xIllegal
[
    StdErr cr; nextPutAll: 'illegal character: '; print: nextChar; cr; halt.
]
