{ import: tobject }

{
  printf("Hello, world\n");
}

Object ()

Object ping
{
  printf("!");
}

{
  _send(s_ping, v_Object);
}

[
  Object ping.
]

Object pong
[
    { printf("?\n"); }
]

[
  Object ping.
  Object pong.
  Object ping; pong; ping; ping; ping; pong; ping; pong.
]

Object _clone
[
    ^self _vtable _alloc: self _sizeof
]

Object initialise []

Object new
[
    ^self _clone initialise
]

Object == anObject
{
  return (v_self == v_anObject) ? v_Object : 0;
}

SmallInteger : Object ()			{ pragma: type integer SmallInteger }
[
    SmallInteger _beTagType
]

SmallInteger _value
{
  return (oop)(((int)v_self) >> 1);
}

SmallInteger value_: _int
{
  return (oop)((((int)v__int) << 1) | 1);
}

SmallInteger + aNumber
[
    {
      if ((int)v_aNumber & 1)
        return (oop)(((((int)v_self >> 1) + ((int)v_aNumber >> 1)) << 1) | 1);
    }.
    self primitiveFailed.
]

SmallInteger - aNumber
[
    {
      if ((int)v_aNumber & 1)
        return (oop)(((((int)v_self >> 1) - ((int)v_aNumber >> 1)) << 1) | 1);
    }.
    self primitiveFailed.
]

SmallInteger < aNumber
[
    {
      if ((unsigned)v_aNumber & 1)
        return ((int)v_self < (int)v_aNumber) ? v_self : v_nil;
    }.
    self primitiveFailed.
]

SmallInteger print
{
  fprintf(stdout, "%d", ((int)v_self >> 1));
  fflush(stdout);
}


Character : Object ( value )			{ pragma: type character Character }

Character value_: _int
[
   self := self new.
   value := SmallInteger value_: _int.
]

Character _put: _value
{
  fputc((int)v__value, stdout);
  fflush(stdout);
}

Character put
[
  self _put: value _value
]

ImmutableString : Object ( size elements )	{ pragma: type string ImmutableString }

ImmutableString size_: _size value_: _bytes
[
   self := self new.
   {
      char *bytes= (char *)v__bytes;
      self->v_size= (oop)strlen(bytes);
      self->v_elements= (oop)strdup(bytes);
   }.
]

ImmutableString value_: _bytes
[
   ^self size_: nil value_: _bytes
]

ImmutableString put
{
  fwrite((char *)self->v_elements, 1, (size_t)self->v_size, stdout);
  fflush(stdout);
}

ImmutableString print
[
  $' put.
  self put.
  $' put.
]

Object primitiveFailed
[
    self error: 'a primitive has failed'
]

Object error: aMessage
[
    'error: ' put.
    aMessage putln.
    { exit(1);  /* ((void (*)(void))0)();  assert(0); */ }.
]

_object debugName
[
    ^ImmutableString value_: self _debugName
]

_object print
[
    self debugName put
]

_object println
[
    self print.
    $\n put.
]

Object putln
[
    self put.
    $\n put.
]

[
    'Hello\n' put.
    'Hello\n' put.
    'Goodbye\n' put.
    42 println.
    'Goodbye\n' put.
]

UndefinedObject : Object ()
[
    UndefinedObject _beNilType
]

nil : UndefinedObject ()			{ pragma: type nil nil }
{
  v_nil= 0;
  _id_export("nil", v_nil);
}

UndefinedObject print
[
    'nil' put
]

true : Object ()				{ pragma: type true true }

[
    true := Object.
]

false : UndefinedObject ()			{ pragma: type false false }

{
  v_false= 0;
  _id_export("false", v_false);
}

[
    nil println.
    true println.
    false println.
    _object println.
]

StaticBlockClosure : Object ( _function _arity )	{ pragma: type staticClosure StaticBlockClosure }

StaticBlockClosure function_: _implementationAddress arity_: _argumentCount
[
  { v_self= _alloc(v_self, sizeof(struct t_StaticBlockClosure)); }.	"allocate primitively for speed"
    _arity    := _argumentCount.
    _function := _implementationAddress.
]

StaticBlockClosure errorArity0	[ ^self error: 'this block expects 0 arguments' ]
StaticBlockClosure errorArity1	[ ^self error: 'this block expects 1 arguments' ]
StaticBlockClosure errorArity2	[ ^self error: 'this block expects 2 arguments' ]
StaticBlockClosure errorArity3	[ ^self error: 'this block expects 3 arguments' ]

StaticBlockClosure value
[
    {
      if ((int)self->v__arity == 0)
        return ((_imp_t)(self->v__function))(v__closure, v_self);
    }.
    ^self errorArity0
]

StaticBlockClosure value: a
[
    {
      if ((int)self->v__arity == 1)
        return ((_imp_t)(self->v__function))(v__closure, v_self, v_a);
    }.
  ^self errorArity1
]

StaticBlockClosure value: a value: b
[
    {
      if ((int)self->v__arity == 2)
        return ((_imp_t)(self->v__function))(v__closure, v_self, v_a, v_b);
    }.
  ^self errorArity2
]

StaticBlockClosure value: a value: b value: c
[
    {
      if ((int)self->v__arity == 3)
        return ((_imp_t)(self->v__function))(v__closure, v_self, v_a, v_b, v_c);
    }.
  ^self errorArity3
]


BlockClosure : StaticBlockClosure ( outer state _nlr )	{ pragma: type fullClosure BlockClosure }

BlockClosure function_: _implementationAddress arity_: _argumentCount
	     outer: outerBlock state: variableArray nlr_: _dynamicEnvironment
[
  { v_self= _alloc(v_self, sizeof(struct t_BlockClosure)); }.	"allocate primitively for speed"
    _function := _implementationAddress.
    _arity    := _argumentCount.
    outer     := outerBlock.
    state     := variableArray.
    _nlr      := _dynamicEnvironment.
]

{ import: testf }
